procedure iss_stack_0 (filelist,sname,chip)

##############################################################
#  Written by P McCarthy and J Wilson, 4/25/02		     #
#							     #
# For each dither sequence, finds offset of each frame w/r/t #
# the REFERENC frame by comparing frame's coordinates for a #
# user selected group of stars to the coordinates for those  #
# stars in the REFERENC frame. Writes offset values (in     #
# pixels) into the header of the isx and icx files as XOFF   #
# and YOFF, as well as the REFERENC frame  (keyword	     #
# REFERENC).						     #
# Input is a list of the isx*c1.fits files.		     #
# NOTE: Must start display tool before running this task     #
#							     #
##############################################################

struct	  *list1, *list2
string	  filelist	{prompt="List of is2 input files"}
string    sname         {prompt="Root name for stacks"}
string    chip          {prompt="chip to use"}


begin

string	  filename, fname
string    chip_num, root_name, anothername, type
string    astro_list, root, keep
file	  offsets.dat
real      xshift, yshift, xoff, yoff, rax, decx, xs, ys


# initialize variables

   pclear ("offsets.dat")
   pclear ("flist")
   pclear ("offsets.dat")
   pclear ("imcen")
   pclear ("sex.fits")
       set stdimage=imt1024

# loop through files and get offsets, write to file
  list1 = ""; list1=filelist
  while (fscan (list1,filename) != EOF)  {

# find the first position in each dither sequence 

       root_name = substr(filename,1,11)

       keypar (root_name//chip//".fits", "XOFF2", silent+)
       xshift = real(keypar.value)
       keypar (root_name//chip//".fits", "YOFF2", silent+)
       yshift = real(keypar.value)


       print (root_name//chip//".fits",>>"flist")
       print (xshift," ",yshift,>>"offsets.dat")
 }
 
 
       pclear("stack_"//sname//"_c"//chip//".fits")
       imcombine("@flist","stack_"//sname//"_c"//chip//".fits",offsets="offsets.dat",combine="average", scale="none")
       display("stack_"//sname//"_c"//chip//".fits",3,fill+,zs+,erase+,bor+)



end

