procedure p_izp_copy ( copy_pairs )

string copy_pairs
struct *list1, *list2

#  Copies izp_00NNN_001 into icp_02001
#         izp_00NNN_002      icp_02002, etc
#
#  from the lists in 'copy_pairs'.
#  Assumes that all the relevant izp and idf frames exist.
#  Assumes that the first idf frames of each set contain 
#  XFID,YFID values.
#
#  Also adds the keyword 'NCOMBINE' (value=1) as this is needed
#  for 'chen'-stacking. 
#
#  Also creates the new files 'std_repairs' and "unc_repairs'.
#  The input files 'std_pairs' and 'obj_pairs' MUST EXIST. 
#
#
#
#


begin
	real xfid, yfid
	string sti, sti1, sto1, stp1, stp2
	int i, i1, i2, o1, o2, p1, p2
	int c1, c2, c3, c4, s1, s2

	list1 = "" ; list1 = copy_pairs
	while ( fscan ( list1, i1, i2, o1, o2 ) != EOF )  {

	p1 = o1 - 2
	  for ( i = i1; i <= i2 ; i += 1 ) 	{
	    p1 += 2 ; p2 = p1 + 1
	    padindex(i)  ; sti  = padindex.output
	    padindex(p1) ; stp1 = padindex.output
	    padindex(p2) ; stp2 = padindex.output

	pclear( "icp_"//stp1 ) ; pclear( "icp_"//stp2 )
	  imcopy ( "izp_"//sti//"_001", "icp_"//stp1 )
	  imcopy ( "izp_"//sti//"_002", "icp_"//stp2 )
						}
	padindex(i1) ; sti1 = padindex.output
	padindex(o1) ; sto1 = padindex.output
	keypar("idf_"//sti1,"xfid") ; xfid = real(keypar.value)
	keypar("idf_"//sti1,"yfid") ; yfid = real(keypar.value)

        parkey (xfid, "icp_"//sto1, "XFID", add+) 
        parkey (yfid, "icp_"//sto1, "YFID", add+) 
	parkey (1,    "icp_"//sto1, "NCOMBINE", add+)
							}

#  Produce 'unc_repairs'

	pclear ( "unc_repairs" ) ; pclear ( "std_repairs" )
	pclear ( "s12" ) ; pclear ( "s34" )

	list1 = "" ; list1 = "obj_pairs"
	while ( fscan ( list1, i1, i2 ) != EOF ) {

	  list2 = "" ; list2 = copy_pairs
	  while ( fscan ( list2, c1, c2, c3, c4 ) != EOF )	{

	     if ( i1 == c1 && i2 == c2 ) print ( c3,"   ",c4, >> "unc_repairs" )
								}
						 }
#  Produce 'std_repairs'

	list1 = "" ; list1 = "std_pairs"
	while ( fscan ( list1, s1, s2, i1, i2 ) != EOF ) {

	  list2 = "" ; list2 = copy_pairs
	  while ( fscan ( list2, c1, c2, c3, c4 ) != EOF )	{

	     if ( s1 == c1 && s2 == c2 ) print ( c3,"   ",c4, >> "s12" )
								}

	  list2 = "" ; list2 = copy_pairs
	  while ( fscan ( list2, c1, c2, c3, c4 ) != EOF )	{

	     if ( i1 == c1 && i2 == c2 ) print ( c3,"   ",c4, >> "s34" )
								}
!paste s12 s34 > std_repairs
						 	 }
end



