procedure p_make_dome_flat ( camera, f1, f2 )

string camera
int f1, f2

#	/home/persson/iraf/panic_scripts/p_make_dome_flat.cl
#
#	Assumes that 'icp' linearized and loop-combined frames 
#	exist. 'f1' and 'f2' are the lamp-on and lamp-off
#	frame numbers. 

#	The filter is taken out of each header and checked for 
#	consistency.


begin
	int i, nloops
	real oldexp, newexp
	string onumber1, onumber2, date
	string filter1_f1, filter2_f1, filter1_f2, filter2_f2

#	Get filters and date out of headers

	padindex(f1) ; onumber1 = padindex.output
	padindex(f2) ; onumber2 = padindex.output

	keypar("icp_"//onumber1//".fits", "FILTER1",silent+)
	filter1_f1 = keypar.value

	print ( filter1_f1 )

	keypar("icp_"//onumber1//".fits", "FILTER2",silent+)
	filter2_f1 = keypar.value

	print ( filter2_f1 )


	keypar("icp_"//onumber2//".fits", "FILTER1",silent+)
	filter1_f2 = keypar.value

	keypar("icp_"//onumber2//".fits", "FILTER2",silent+)
	filter2_f2 = keypar.value

	keypar("icp_"//onumber1//".fits", "NIGHT",silent+)
	date = "_"//keypar.value

	if ( filter1_f1 == filter1_f2 && filter2_f1 == filter2_f2)	{

	pclear ("flat")
	imarith ( "icp_"//onumber1, "-", "icp_"//onumber2, "flat" )

# 	Normalize to the mode of the lamp-on minus lamp-off difference image
#	Note that the output image is positive
  
	pclear ( "npdflat"//filter1_f1//filter2_f1//date )
	p_normalize ( "flat", "npdflat"//filter1_f1//filter2_f1//date )
	p_store ( "npdflat"//filter1_f1//filter2_f1//date )

							}	else	{
	print ( "" )
	print ( "  >> SORRY: Filters are not consistent " )
	print ( "" )
							}
end





