procedure p_sky4 ( p1, p2, p3, p4, p5, p6 )

int p1, p2, p3, p4, p5, p6 
struct *list1

#  Used to sky-subtract crowded-field frames
#  using sky frames created by 'p_skysub' operating 
#  on the off-source frames. 

begin
	string pre, sp1, sp3, sp4, sp5, sp6, isx_frame, idf_frame, root_name
	real etime1, etime3, etime5

	  padindex(p1); sp1 = padindex.output
	  padindex(p3); sp3 = padindex.output
	  padindex(p4); sp4 = padindex.output
	  padindex(p5); sp5 = padindex.output
	  padindex(p6); sp6 = padindex.output

#  In general cannot scale sky frame to median of crowded frame.
#  Also cannot just subtract, because exptimes may be different.
#  So, scale skies by exptimes relative to source frames p1 - p2. 

	pclear ("sky") ; pclear ("sky3"); pclear ("sky5")
if ( access ( "sky_"//sp3//sp4//".fits") && access ( "sky_"//sp5//sp6//".fits")) {

	  keypar("idf_"//sp1,"EXPTIME",silent+)
	  etime1 = real(keypar.value)

	  keypar("sky_"//sp3//sp4,"EXPTIME",silent+)
	  etime3 = real(keypar.value)

	  keypar("sky_"//sp5//sp6,"EXPTIME",silent+)
	  etime5 = real(keypar.value)

	imarith("sky_"//sp3//sp4,"/",etime3,"sky3")
	imarith("sky_"//sp5//sp6,"/",etime5,"sky5")

	  imarith ( "sky3", "+", "sky5", "sky")
	  imarith ( "sky","/", 2., "sky")
	  imarith ( "sky","*", etime1, "sky")

		}  else { 
	psorry ("Off-source sky frame ") 
			}
	
#  Now go through list of 'idf' frames

	p_pre_list ( "idf", p1, p2 )

	list1 = "" ; list1 = "idf_list"
	while ( fscan ( list1, idf_frame ) != EOF ) 	{

             root_name = substr(idf_frame,5,9)
	     isx_frame = "isx_"//root_name//".fits"
             pclear (isx_frame )

	imar ( idf_frame, "-", "sky", isx_frame )

#	Remove residual sky treated as a constant (the median) for now.

	  p_offset_level ( isx_frame, "median" )

#	Set frame edges to zero

	  p_zero_edges ( isx_frame )
							}
end
