procedure p_stack (p1, p2, sname)

##############################################################
#  Written by P McCarthy and J Wilson, 8/18/99		     #
# Modified 9/5/02                                            # 
# For each dither sequence, finds offset of each frame w/r/t #
# the REFERENC frame by comparing frame's coordinates for a  #
# user selected group of stars to the coordinates for those  #
# stars in the REFERENC frame. Writes offset values (in      #
# pixels) into the header of the is2 and idf files as XOFF2  #
# and YOFF2, as well as the REFERENC frame  (keyword	     #
# REFERENC).						     #
# Input is a list of the is2*.fits files.		     #
# NOTE: Must start display tool before running this task     #
#							     #
###############################################################
#
#	Revised 10mar2004   SEP.
#	  Now takes p1,p2 input and created 'is2_list'
#
#

int p1, p2
string    sname         {prompt="Root name for stacks"}
struct	  *list1, *list2


begin

string	  filelist, filename, fname
string    root_name, anothername, type
string    astro_list, root, keep, update, stack
file	  offsets.dat
real      xshift, yshift, xoff, yoff, rax, decx, xs, ys
real      xdif, ydif, x1, y1, x2, y2

	p_pre_list ( "is2", p1, p2 )
	filelist = "is2_list"

# initialize variables

   pclear ("offsets.dat")
   pclear ("flist")
   pclear ("offsets.dat")
   pclear ("imcen")
   pclear ("sex.fits")

#       set stdimage=imt1024

# loop through files and get offsets, write to file
  list1 = ""; list1=filelist
  while (fscan (list1,filename) != EOF)  {

# find the first position in each dither sequence 

       root_name = substr(filename,1,9)

       keypar (root_name//".fits", "XOFF2", silent+)
       xshift = real(keypar.value)
       keypar (root_name//".fits", "YOFF2", silent+)
       yshift = real(keypar.value)


       print (root_name//".fits",>>"flist")
       print (xshift," ",yshift,>>"offsets.dat")
 }
 
 
       pclear("stack_"//sname//".fits")
       imcombine("@flist","stack_"//sname//".fits",offsets="offsets.dat",combine="average", masktyp="badvalue", maskval=1., scale="none")
       display("stack_"//sname//".fits",2,fill+,zs+,erase+,bor+)


       imrename ("stack_"//sname//".fits","sex.fits")

!      sex sex.fits -c default_is2.sex 
!          egrep -v '#' sex.cat >sex.list
!          awk '{print $9, $10}' sex.list >objects.dat

       imrename ("sex.fits","stack_"//sname//".fits")

           pclear("sex.cat")
           pclear("sex.list")
           tvmark (2, coords="objects.dat", mark="circle", radii="10",color=205)

      imcentroid ("@flist", reference="stack_"//sname//".fits",coords="objects.dat",maxshift=20,shifts="offsets.dat",verbose-,>"imcen")


!          grep fits imcen > pp

!          awk '{print $2,$4}' pp >new_offsets.dat

!      paste offsets.dat new_offsets.dat >kk

!      awk '{print $1-$3,$2-$4}' kk >dif

!      head -1 dif >dif2

       pclear ("newer_offsets.dat")
       list2 = " " ; list2 = "dif2"
       while (fscan (list2,xdif,ydif) != EOF)  { }

       list2 = " " ; list2 = "new_offsets.dat"
       while (fscan (list2,x1,y1) != EOF)  {
       		x2 = x1 + xdif
       		y2 = y1 + ydif
       		print (x2," ",y2,>>"newer_offsets.dat") }

        pclear("stack_"//sname//"a.fits")

       imcombine("@flist","stack_"//sname//"a.fits",offsets="newer_offsets.dat",combine="average", scale="none")

       display("stack_"//sname//"a.fits",3,fill+,zs+,erase+,bor+)
       imexamine ("stack_"//sname//"a.fits",3)

           print ("")
           print ("")
           print ("")
           print ("")
           print ("")
           print ("")
           print ( " >>>>> update offsets in headers? (y/n)"  )
           scan (update)
           print ("")

           if (update == "y") {

!      paste flist newer_offsets.dat > nlist.dat

      list1 = ""; list1="nlist.dat"
        while (fscan (list1,fname,x, y) != EOF)  {
          xoff = x
          yoff = y

          hedit (fname,"XOFF2",xoff,add+)
          hedit (fname,"YOFF2",yoff,add+)

         }

         print ( " Headers updated"  )
} 
         else {
       
         print ("") ; print ("") ; print ("")
         print ( " Headers not changed"  )
         print ("")

}

         print ("") ; print ("") ; print ("") ; print ("") ; print ("") ; print ("")

           print ( " >>>>> Write input files for stacking program? (y/n)"  )
           scan (stack)
           print ("")

           if (stack == "y") {
  
!      paste flist newer_offsets.dat > nlist.dat

           pclear("comblist_"//sname)

           list1 = ""; list1="nlist.dat"
        while (fscan (list1,fname,x, y) != EOF)  {

           root = substr(fname,1,9)
           keypar (fname, "RA", silent+)
           rax = real(keypar.value)
           keypar (fname, "DEC", silent+)
           decx = real(keypar.value)
           keypar (fname, "XOFF2", silent+)
           xs = real(keypar.value)
           keypar (fname, "YOFF2", silent+)
           ys = real(keypar.value)
 
           print ("      ",root," ",rax," ",decx," ",xs," ",ys,>>"comblist_"//sname)

         }
         }
         else {
                print ("comblist files not written")
         }

end
