procedure stdphot

#######################################################
#						      #
#  Written by P McCarthy and J Wilson, 9/15/99        #
#  Uses std*list files made by stdsort to do	      #
#  aperture photometry on the std star frames	      #
#  and produces a table showing magnitudes for each   #
#  frame and aperture size, grouped by star and       #
#  filter, and gives zeropoints calculated from       #
#  average magnitudes for each star/filter/aperture.  #
#  Output table is written to a file called	      #
#  std_summary. (modified by K.Koviak 2/12/03)	      #
#						      #
#######################################################

struct	*list1, *list2, *lista

begin


# Declarations
  file		afile, stdlist
  string	listname, time, linefile
  string        filter_name, sname, name, aname, brname, bname
  string	slist, starsort, sublist, header, lname, fname
  string	tmpname, old_filt, old_name, path
  string	zeropts, objlist, objname, blankline, filtname
  real          mag, tabmag, amass, junk1, junk2, junk3
  real		avg1, avg2, avg3, avg4, avg5, avg6, avg7, avg8
  real		avg9, avg10, zpt1, zpt2, zpt3, zpt4, zpt5
  real		zpt6, zpt7, zpt8, zpt9, zpt10
  real		sumzpt1, sumzpt2, sumzpt3, sumzpt4, sumzpt5
  real		sumzpt6, sumzpt7, sumzpt8, sumzpt9, sumzpt10
  int		aperline, aperline2, apsize
  int		a, b, c, d, e, f, g, h, m, n

# Make sure variables are clean, initialized
  fname = ""
  apsize = 0.0
  zpt1 = 0.0
  zpt2 = 0.0
  zpt3 = 0.0
  zpt4 = 0.0
  zpt5 = 0.0
  zpt6 = 0.0
  zpt7 = 0.0
  zpt8 = 0.0
  zpt9 = 0.0
  zpt10 = 0.0
  sumzpt1=0
  sumzpt2=0
  sumzpt3=0
  sumzpt4=0
  sumzpt5=0
  sumzpt6=0
  sumzpt7=0
  sumzpt8=0
  sumzpt9=0
  sumzpt10=0

  pclear ("phot.out")
  pclear ("zpt_summary")
  pclear ("avg_summary")
  pclear ("zpt_summary2")
  pclear ("avg_summary2")
  pclear ("header")
  pclear ("std_summary")
  pclear ("results.dat")
  pclear ("linefile")
  pclear ("aperline")
  pclear ("aperline2")
  pclear ("starsort")
  pclear ("objlist")
  pclear ("star_summary")

set stdimage = "imt2048"

# make a list of the std lists output by stdsort
  files ("std_*_list", > "starsort")

  list1 = ""; list1 = "starsort"
# this opens while loop #1, scanning the list of std lists
  while(fscan(list1,listname) != EOF) {

  # initialize counting variable for finding avg zpt for each aperture
    a=0 #aperture=1
    b=0 #aperture=2
    c=0 #aperture=3
    d=0 #aperture=4
    e=0 #aperture=5
    f=0 #aperture=6
    g=0 #aperture=7
    h=0 #aperture=8
    m=0 #aperture=9
    n=0 #aperture=10
    sumzpt1=0
    sumzpt2=0
    sumzpt3=0
    sumzpt4=0
    sumzpt5=0
    sumzpt6=0
    sumzpt7=0
    sumzpt8=0
    sumzpt9=0
    sumzpt10=0
    avg1=0
    avg2=0
    avg3=0
    avg4=0
    avg5=0
    avg6=0
    avg7=0
    avg8=0
    avg9=0
    avg10=0
    pclear ("avg_summary")
    pclear ("avg_summary2")
    pclear ("zpt_summary")
    pclear ("zpt_summary2")

   list2 = "" ; list2 = listname
# this opens while loop #2, scanning each file in the list
   while (fscan(list2,fname) != EOF) {
   
      keypar (fname, "stdmag")
      tabmag = real(keypar.value)
      keypar (fname, "OBJECT")
      objname = str(keypar.value)
      keypar (fname, "FILTER")
      filtname = str(keypar.value)
      keypar (fname, "airmass")
      amass = real(keypar.value)
      keypar (fname, "DATE")
      time = str(keypar.value)

     
# set up phot task parameters
       datapars.exposur= "EXPTIME"
       photpars.zmag = 26.0
       photpars.aperture = "1,2,3,4,5,6,7,8,9,10"
       datapars.scale = 0.096
       centerpars.cbox = 2.5
       fitskypars.salgorithm = "median"
       fitskypars.annulus = 12
       fitskypars.dannulus = 5

# display standard and do aperture photometry with phot
      display (fname,1,xmag=1,ymag=1)
     
       pclear ("results.dat") 
print (">>>Choose the standard star using the space bar, then q in ximtool, q in iraf window")

#mike had to fix bad pixels. Mask name needs to be improved
#    imdel('temp'//fname,verify=no)
#    imcopy(fname,'temp'//fname)
#    fixpix('temp'//fname,'maskfoo')
#    phot ('temp'//fname,output="results.dat") 


    phot (fname,output="results.dat") 
    pclear ("phot.out")
      
     tail ("results.dat",nlines=10,>>"phot.out")

# read aperture and magnitude values from phot output

  lista=""; lista="phot.out"
# this opens loop #3, scanning each file's phot.out
  while (fscan(lista,apsize,junk1,junk2,junk3,mag) !=EOF) {

# USE JUNK3 VAR TO KEEP SKY COUNTS?
if (mag==INDEF)
   {mag=0}

      if (apsize==1.00 && mag != 0) 
	 {zpt1 = 26.0 + tabmag - mag
	 sumzpt1=sumzpt1+zpt1
	 a=a+1}

      if (apsize==2.00 && mag != 0) 
	 {zpt2 = 26.0 + tabmag - mag
	 sumzpt2=sumzpt2+zpt2
	 b=b+1}

      if (apsize==3.00 && mag != 0) 
	 {zpt3 = 26.0 + tabmag - mag
	 sumzpt3=sumzpt3+zpt3
	 c=c+1}

      if (apsize==4.00 && mag != 0) 
	 {zpt4 = 26.0 + tabmag - mag
	 sumzpt4=sumzpt4+zpt4
	 d=d+1}

      if (apsize==5.00 && mag != 0) 
	 {zpt5 = 26.0 + tabmag - mag
	 sumzpt5=sumzpt5+zpt5
	 e=e+1}

      if (apsize==6.00 && mag != 0) 
	 {zpt6 = 26.0 + tabmag - mag
	 sumzpt6=sumzpt6+zpt6
	 f=f+1}

      if (apsize==7.00 && mag != 0) 
	 {zpt7 = 26.0 + tabmag - mag
	 sumzpt7=sumzpt7+zpt7
	 g=g+1}
	
      if (apsize==8.00 && mag != 0) 
	 {zpt8 = 26.0 + tabmag - mag
	 sumzpt8=sumzpt8+zpt8
	 h=h+1}

      if (apsize==9.00 && mag != 0) 
	 {zpt9 = 26.0 + tabmag - mag
	 sumzpt9=sumzpt9+zpt9
	 m=m+1}

      if (apsize==10.00 && mag != 0)
	 {zpt10 = 26.0 + tabmag - mag
	 sumzpt10=sumzpt10+zpt10
	 n=n+1}


}     #closing brace 3, closes brsub_idf*fits file's phot.out reading
 
# make table of phot values for each star, appending a line for
# each file in the std list
print (zpt1//"   "//zpt2//"   "//zpt3//"   "//zpt4//"   "//zpt5//"   "//zpt6//"   "//zpt7//"   "//zpt8//"   "//zpt9//"   "//zpt10//"   "//amass//"   "//time, >> "zpt_summary")

# reformat tables for each star
! awk '{printf ("%-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.3f %s\n", $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12)}' zpt_summary >> zpt_summary2

zpt1=0
zpt2=0
zpt3=0
zpt4=0
zpt5=0
zpt6=0
zpt7=0
zpt8=0
zpt9=0
zpt10=0
pclear ("zpt_summary")

}      #closes loop 2, moves on to next brsub file in std*list

# calculate avg zeropts for each aperture
avg1=sumzpt1/a
avg2=sumzpt2/b
avg3=sumzpt3/c
avg4=sumzpt4/d
avg5=sumzpt5/e
avg6=sumzpt6/f
avg7=sumzpt7/g
avg8=sumzpt8/h
avg9=sumzpt9/m
avg10=sumzpt10/n

print (avg1//"   "//avg2//"   "//avg3//"   "//avg4//"   "//avg5//"   "//avg6//"   "//avg7//"   "//avg8//"   "//avg9//"   "//avg10, >> "avg_summary")

! awk '{printf ("%-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f\n", $1, $2, $3, $4, $5, $6, $7, $8, $9, $10)}' avg_summary  >> avg_summary2


pclear ("header")
print (objname//"_"//filtname//"-----------------------------------------------------------------------" ,> "header")

pclear ("linefile")
print ("______________________________________________________________________________" ,> "linefile")

pclear ("blankline")
print ("                                                                               " ,> "blankline")


!cat  header zpt_summary2 linefile avg_summary2 blankline >> star_summary



}      #closes loop3, moves on to next std*list file

print ("1 2 3 4 5 6 7 8 9 10 airmass time" ,> "aperline")
! awk '{printf ("%-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %-7.2f %s %s\n", $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12)}' aperline >> aperline2

! pwd > "path"
!cat path aperline2 star_summary > std_summary

# clean up 

pclear ("aperline")
pclear ("aperline2")
pclear ("avg_summary")
pclear ("avg_summary2")
pclear ("blankline")
pclear ("header")
pclear ("linefile")
pclear ("magline")
pclear ("magval")
pclear ("mean")
pclear ("path")
pclear ("phot.out")
pclear ("results.dat")
pclear ("standard_list")
pclear ("star_summary")
pclear ("starsort")
pclear ("tmpname")
pclear ("zpt_summary2")

end
