procedure stdsky ( p1, p2 )

int p1, p2

#######################################################
#						      #
#  Written by P McCarthy and J Wilson, 9/15/99        #
#  pulls standard stars from list, sky		      #
#  subtracts to prep for stdsort task. Input is	      #
#  idf*c1.fits list. Output is sub*fits files.	      #
#						      #
#######################################################

struct	  *list1, *list2, *lista
file	  	{prompt="List of input idf*c1.fits files"}

begin

# Declarations

  file          filelist
  file		afile
  string        filter_name, filter_old, anothername, slist, sublist
  string        filename, type, name, fname, sname, bname, brname
  real          exposure, ra, dec, ra_old, dec_old
  real          ra_dif, dec_dif, exposure_old, exp_dif
  real          mag1, mag2, mag3, aperline, aperline2
  real          mag, mag4, mag5, mag6, aper, linefile
  real          zmag, hzpt, jzpt, kzpt, mag7, mag8, mag9, mag10 
  int           i, k, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10
  

  set stdimage = "imt1024"

#	Create list

	p_pre_list ( "idf", p1, p2 )
	filelist = "idf_list"

# Make sure variables are clean, initialized

  ra_old = 0.
  dec_old = 0.
  exposure_old = 0.0
  filter_old = ""
  i = 0
  k = 0
  mag = 0.0
  mag1 = 0.0
  mag2 = 0.0
  mag3 = 0.0
  mag4 = 0.0
  mag5 = 0.0
  mag6 = 0.0
  mag7 = 0.0
  mag8 = 0.0
  mag9 = 0.0
  mag10 = 0.0
  n1 = 0
  n2 = 0
  n3 = 0
  n4 = 0
  n5 = 0
  n6 = 0
  n7 = 0
  n8 = 0
  n9 = 0
  n10 = 0

  delete ("sub_idf*fits", verify=no, >& "dev$null")
  delete ("brsub_idf*fits", verify=no, >& "dev$null")
  pclear ("sky_list")
  pclear ("sky_list2")
  pclear ("sublist")
  pclear ("slist")
  pclear ("results.dat")
  pclear ("linefile")
  pclear ("aperline")
  pclear ("aperline2")

# pull out "standard" files into separate list
       lista = "" ; lista = filelist
       pclear ("standard_list")
       while (fscan(lista,anothername) !=EOF) {
       keypar (anothername,"OBSTYPE",silent+)
       type = str(keypar.value)

    if (type == "standard") print (anothername,>>"standard_list")
}
       tail ("standard_list", nlines=15)


# now read standard list and create skies

       lista = "" ; lista = "standard_list"
       while (fscan (lista,filename) !=EOF) {


#  get header keywords

       keypar (filename, "RA", silent+)
       ra = real(keypar.value)
       keypar (filename, "DEC", silent+)
       dec = real(keypar.value)
       keypar (filename, "FILTER", silent+)
       filter_name = str(keypar.value)
       keypar (filename, "EXPTIME", silent+)
       exposure = real(keypar.value)
       keypar (filename, "OBSTYPE", silent+)
       type = str(keypar.value)
       keypar (filename, "OBJECT", silent+)
       name = str(keypar.value)

       ra_dif = ra - ra_old
       dec_dif = dec - dec_old
       exp_dif = exposure - exposure_old

# decide if we are on a new pointing or not
# write file names into sky list until we are on new field.

       if (ra_dif  >=  1.0)  i = 0
       if (dec_dif >=  1.0)  i = 0
       if (exp_dif !=  0.0)  i = 0
       if (filter_name != filter_old) i = 0

       if (k!=0) {
       if (i==0) {

# sky_list is list of files in a single pointing
       list1 = "" ; list1 = "sky_list"
       while (fscan(list1, fname) !=EOF) {

# make list of sky frames excluding object

         list2 = "" ; list2 = "sky_list"
         while (fscan(list2,sname) !=EOF) {
         if (sname != fname)
# sky_list2 is list of files in pointing EXCEPT frame to be sky subtracted
         print (sname,>>"sky_list2")
  } 

# now make the sky image
    if (access ("sky_list2")) {
       tail ("sky_list2",nlines=15)
       pclear ("sky.fits")
       imcombine ("@"//"sky_list2","sky.fits",combine="median",scale="mode",reject="none",masktyp="none")
       
# subtract sky and display
       pclear ("sky_list2")
       pclear ("sub"//fname)
       imarith (fname,"-","sky.fits","sub_"//fname,calctyp="real", pixtype="real")
       display ("sub_"//fname,1,xmag=1, ymag=1)

} # close if access sky_list2 loop
  else { }
       
} # close inner while

       pclear ("sky_list")
       pclear ("sky_list2")
       print (filename,>>"sky_list")

} # close if i = 0

       else {print (filename, >> "sky_list") }

       i = i + 1
       k = k + 1
       ra_old = ra
       dec_old = dec
       exposure_old = exposure
       filter_old = filter_name

} # close k!=0
       else {
       i = i + 1
       k = k + 1
       ra_old = ra
       dec_old = dec
       exposure_old = exposure
       filter_old = filter_name
       print (filename,>>"sky_list")  }


} # close main while

# process last sky_list
       list1 = "" ; list1 = "sky_list"
       while (fscan(list1, fname) !=EOF) {

# make list of sky frames excluding object

         list2 = "" ; list2 = "sky_list"
         while (fscan(list2,sname) !=EOF) {
         if (sname != fname)
         print (sname,>>"sky_list2")
  } 
       tail ("sky_list2",nlines=15)
       pclear ("sky.fits")
       imcombine ("@"//"sky_list2","sky.fits",combine="median",scale="mode",reject="none",masktyp="none")
       
       pclear ("sky_list2")
       pclear ("sub"//fname)
       imarith (fname,"-","sky.fits","sub_"//fname,calctyp="real", pixtype="real")
       display ("sub_"//fname,1,xmag=1, ymag=1)
       
} # close inner while

       pclear ("sky_list")
       pclear ("sky_list2")

       delete ("sky.fits")

end

