procedure stdsort


#######################################################
#						      #
#  Written by P McCarthy and J Wilson, 4/24/02        #
#  Task block replicates sky subtracted, flattened    #
#  std star frames, sorts them by object and sorts    #
#  them by filter & populates stdmag in header with   #
#  value from Eric's table to pass on to the stdphot  #
#  task.				              #
#						      #
#######################################################

struct	  *list1, *lista

begin

# Declarations
  string	sublist, sname, brname, blist, bname
  string	obj_name, filt_name, old_obj, old_filt
  string	tmpname, magline, magval, objlist, mag

# Make sure variables are clean, initialized
  i=0
  delete ("brsub*fits", verify=no, >& "dev$null")
  delete ("std_*_list", verify=no, >& "dev$null")
  pclear ("sublist")
  pclear ("blist")
  pclear ("tmpname")
  pclear ("magline")
  pclear ("magval")
  pclear ("objlist")


  set stdimage = "imt1024"

# make list of sky subtracted standards

       files ("sub_idf*.fits",>>"sublist")

#block replicate images
   list1 = ""; list1 = "sublist"
   while (fscan (list1,sname) != EOF ) {
      brname = "br"//sname
      print (brname, >> "blist")    }
   
   blkrep ("@"//"sublist", "@"//"blist", 2, 2)
   set stdimage = "imt2048"


#  sorts files by object and filter and populates stdmag in header
#  with value from Eric's table

   list1 = "" ; list1 = "blist"
   while (fscan(list1,bname) !=EOF) {
     keypar (bname, "OBJECT", silent+)
         obj_name = str(keypar.value)
     keypar (bname, "FILTER", silent+)
	 filt_name = str(keypar.value)


#      get standard zeropoint from table
	 pclear ("tmpname")
	 pclear ("magline")
	 pclear ("magval")
       
	 print (obj_name, > "tmpname")
	 !egrep -f tmpname /data/mabel/lcir/scripts/stdmagtable.txt > magline
	 if (filt_name == "Jc")
	    !awk '{print ($9)}' magline > magval
	 if (filt_name == "Hc")
	    !awk '{print ($12)}' magline > magval
	 if (filt_name == "Ks")
	    !awk '{print ($18)}' magline > magval
	 lista = ""; lista = "magval"	    
         while (fscan(lista,mag) != EOF) {
	 parkey (mag, bname, "stdmag", add+)}


   objlist = "std_"//filt_name//"_"//obj_name//"_list"
print (bname, >> objlist)

}

delete ("sublist")
delete ("blist")
#delete ("tmpname")
#delete ("magval")

end
