procedure p_store2 ( framein )

string framein
struct *list1

#  /home/persson/iraf/panic_scripts/p_store.cl
#  Store the mean, median, and mode of a frame in its header
#
#  It does not matter if 'framein' has a '.fits' extension on it.
#
#  Rev  29nov2003     SEP	
#  Rev  08mar2004     SEP:
#  Because PANIC frames have bad-looking edges, restrict the 
#  section for imstat to be well within - leave a 40-pixel 
#  border.
#
#  Rev  24jul2004     SEP:
#  Test to see if can get close to actual sky level, i.e., make 
#  the median insensitve to the presence of bright stars, by 
#  adjusting the imstat limits on the basis of sigma. First try 
#  one iteration.

begin

	real fr_mean, fr_med, fr_mod, sigma, cutup, cutlo

	pclear ( "fr_stats" ) ; pclear ( "fr_stats_file" )

        imstat (framein//"[41:984,41:984]",fields="midpt,stddev",>"fr_stats")
             
        ! tail -1 fr_stats > fr_stats_file

	list1 = "" ; list1 = "fr_stats_file"
	while ( fscan ( list1, fr_med, sigma ) != EOF ) {}

	cutup = fr_med + 3.*sigma 
	cutlo = fr_med - 3.*sigma

	pclear ( "fr_stats" ) ; pclear ( "fr_stats_file" )
        imstat (framein//"[41:984,41:984]",lower=cutlo,upper=cutup,fields="mean,midpt,mode",>"fr_stats")

        ! tail -1 fr_stats > fr_stats_file

	list1 = "" ; list1 = "fr_stats_file"
	while ( fscan ( list1, fr_mean, fr_med, fr_mod ) != EOF ) {}

          hedit (framein,"FRMEAN", fr_mean,update+,add+,verify-)
          hedit (framein,"FRMEDIAN", fr_med,update+,add+,verify-)
          hedit (framein,"FRMODE", fr_mod,update+,add+,verify-)
end
