procedure r_flatten ( type, p1, p2 )

string camera, type
int p1, p2
struct *list1


#	This is the version for RetroCam which has 1 filter wheel
#
#	Assumes that 'icp' linearized and loop-combined frames 
#	exist. 'p1' and 'p2' are the starting and ending 
#	frame numbers of a set. Frames p1 and p2 must exist.
#
#	It is assumed that frames p1 and p2 are on the same date. 
#
#	It is assumed that 'chk_headers' and 'fix_headers' have 
#	been run and that therefore all obstypes are correct. 
#
#	The existence of frames within a set is not assumed (in
#	case it has been necessary to delete some) but is worked
#	around. 
#
#	It is assumed that darks are irrelevant.
#	
#	Only 'astro' and 'standard' obstypes are processed.
#	
#	Flats must exist. The nomenclature is:
#	
#	  nptflatJc_28nov2003.fits    (normalized/panic/twi/flat/filter_date)
#	    
#	     (if it exists). If not, the dome rather than twi flat is used)
#	
#	      If this does not exist, then a canonical flat is taken from 
#	      the flat storage directory. 
#
#	If a flattened frame exists, it is written over.

begin
	string filter, obstyp, date, flat_path, flat, dflat, tflat, sflat
	string icp_frame, idf_frame

	for ( i = p1 ; i <= p2, i += 1 )	{

#	Get filters out of header of each frame in the p1,p2 sequence

	padindex(i) ; onumber1 = padindex.output ; icp_frame = "icp_"//onumber1

	if ( access ( icp_frame )) 	{

	keypar("icp_"//onumber1//".fits", "FILTER",silent+)
	filter = keypar.value

	keypar("icp_"//onumber1//".fits", "NIGHT",silent+)
	date = "_"//keypar.value

	keypar("icp_"//onumber1//".fits", "OBSTYPE",silent+)

	if ( obstyp == 'astro' || obstyp == 'standard' )	{

	  idf_frame = "idf_"//onumber1
	  pclear ( idf_frame )

#	Select flat in priority order: twi, dome, stored

	    tflat = "nrtflat"//filter//date//".fits"
	    dflat = "nrdflat"//filter//date//".fits"

	flat_path = "/home/persson/iraf/flats/"

	    sflat = flat_path//"srtflat"//filter//".fits"

	if ( access ( dflat ))	flat = dflat
	if ( access ( tflat ))	flat = tflat

	if ( !access ( dflat ) && !access ( tflat ))	flat = sflat

	  imarith ( icp_frame, "/", flat, idf_frame )
          hedit (idf_frame,"FLAT", flat,update+,add+,verify-)

#	Store the median value of the frame in its header

	p_store ( idf_frame )

													}
							}
									}
end


















