procedure p_1go ( n1, n2, flag )

int         n1                {prompt="Beginning sequene number"}
int         n2                {prompt="End sequence number"}
string      flag              {prompt="Processing flag (any of nucs)"}
bool        dolin = yes       {prompt="Do Linearization?"}
bool        doloopc = yes     {prompt="Do loop combine?"}
bool        dodark = yes      {prompt="Produce Dark Frames?"}
bool        dodarksub = yes   {prompt="Do Dark Subtraction?"}
bool        dodflat = yes     {prompt="Produce dome flat (and bad pixel mask)?"}
bool        dotflat = yes     {prompt="Produce twilight flat?"}
bool        doflatten = yes   {prompt="Flat-field the frames?"}
bool        fixoffsets = yes  {prompt="Interactively fix offsets?"}
bool        dosigma = yes     {prompt="Produce noise maps?"}
bool        dodistcor = yes   {prompt="Do distortion correction?"}
struct *list1

#  PANIC pipeline for galaxies, standard stars, and 
#  crowded field data.
#  For galaxy data typically square-9 dithers were used.
#  For standard stars typically dice-5 dithers were used. 
#  For crowded fields special sky-creation routines are used;
#    the object data frames themselves are not used.  
#
#  Decode 'flag' to process:
#
#  n      routines that apply to all frames in the night, n1 - n2
#  u      uncrowded frames, e.g., LCIRS galaxies - square-9 dithers
#  c      crowded frames, e.g., rich starfields with separate skies 
#  s      standard stars - dice-5 dithers
#
#  If any of these flags are set, it is expected that the corresponding 
#  pairs files exist:
#
#   u    'unc_pairs'  should exist
#   c    'crd_pairs'    "      "  
#   s    'std_pairs'    "      " 

begin
   int nf, i, p1, p2, p3, p4, p5, p6, k
   bool naf, unc, crd, std
   string onumber, onumber3, onumber4, sky, date
   string flg
   int nn1, nn2

   naf = no ; unc = no ; crd = no ; std = no
   flg = flag
   nn1 = n1
   nn2 = n2
   nf = strlen(flg)
   for ( i = 1; i <= nf; i += 1 )    {
      if ( substr(flg,i,i) == "n") naf = yes 
      if ( substr(flg,i,i) == "u") unc = yes 
      if ( substr(flg,i,i) == "c") crd = yes 
      if ( substr(flg,i,i) == "s") std = yes
   }

   # First off, we load in the files we need
   p_load
#  These are the procedures that apply to all frames

   if(naf) {

      if (dolin) p_linearize ( "p", nn1, nn2 ) 
      p_defaults ( nn1 )
      if (doloopc) p_loops_combine  ( "izp", nn1, nn2 )            
      if (dodark) p_dark ( nn1, nn2 ) 
      if (dodarksub) p_subdk ( nn1, nn2 )

      if (dodflat) {
          if ( access ( "dflat_pairs" ))   {
             list1 = "" ; list1 = "dflat_pairs"
             while ( fscan ( list1, p1, p2 ) != EOF ) {
                p_dflat ( p1, p2 )
             }
          } else {}
      }
 
      if (dotflat) {
         if ( access ( "tflat_pairs" ))   {
            list1 = "" ; list1 = "tflat_pairs"
            while ( fscan ( list1, p1, p2 ) != EOF ) {
               p_tflat ( p1, p2 )
            }
         } else {}
      } else { }

      if (doflatten) p_flatten ( nn1, nn2 )
      # This routine computes the noise of the frame (var_*.fits).
      if (dosigma) p_variance (nn1,nn2)
 
   } else { }

#  Done with procedures that apply to all frames in the night or run.
#  Dealing with 'idf' frames from now on. 
#
#  Now come the several variants of the stacking procedures
#  Do uncrowded frame (e.g. faint galaxy) stacks

# First, let's get the fix-offsets out of the way right at the beginning.
   if (fixoffsets) {
      if(unc) {
         if ( access ( "unc_pairs" )) {
            list1 = "";  list1 = "unc_pairs"
            while ( fscan ( list1, p1, p2 ) != EOF )   {
               p_fx_offsets (p1,p2)
            }
         }
      }
      if(crd)   {
         if ( access ( "crd_pairs" ))   {
            list1 = "";  list1 = "crd_pairs"
            while ( fscan ( list1, p1, p2, p3, p4, p5, p6 ) != EOF )   {
               p_fx_offsets (p1,p2)
            }
         }
      }
      if (std)    {
         if ( access ( "std_pairs" ))   {
            list1 = "" ; list1 = "std_pairs"
            while ( fscan ( list1, p1, p2, p3, p4 ) != EOF ) {
               p_fx_offsets (p1,p2)
            }
         }
      }
   }

   # Now go through and do all the non-interactive stuff         

   if(unc)   {
      if ( access ( "unc_pairs" ))   {

         list1 = "" ; list1 = "unc_pairs"
         while ( fscan ( list1, p1, p2 ) != EOF )   {

            p_sky1   ( "idf", p1, p2 ) 
            if (! fixoffsets) {
               p_dither ( "isx", p1, p2 )   
            }
            p_stk1   ( p1, p2 )
            p_objmask2( p1, p2 )
            p_skysub ( p1, p2 )   
            # Now have 'is2' frames with correct associated 'mcp' mask frames.
            # If NLOOPS=1 delete CRs
            p_crlast ( p1, p2 ) 
            # Now want to correct 'is2' and 'mcp' frames for distortion.
            # These become        'isd' and 'mcd' frames.

            if (dodistcor) {
               p_distcor ( "mcp", "mcd", p1, p2 )
               p_distcor ( "is2", "isd", p1, p2 )
               # Added this to create distortion corrected variance maps
               if (dosigma) {
                  p_distcor ( "var", "vad", p1, p2 )
               }
            }
 
            p_stack  ( p1, p2, "test_"//p1//"_"//p2 ) 
            if (dosigma) p_stack_var (p1, p2, "test_"//p1//"_"//p2)
#           p_hchen  ( "comblist_test_"//p1//"_"//p2, "chen_"//p1//"_"//p2 )
#           display ( "chen_"//p1//"_"//p2, 1 )
         }
      } else {}
   } else {}
#
#  Do crowded frame stacks; off-source sky frames were done before and/or after
 
   if(crd)   {
      if ( access ( "crd_pairs" ))   {

         #  First go through all off-source "sky" frames, creating stacks and 
         # cleaned skies,   for each set of up to two off-source dither 
         #locations.  The 'crd_pairs' file is   first processed to make a 
         #single non-repeating # list of pairs of off-source   position frames
         #; this is 'crdlist'.
      
         mk_crdlist ("crd_pairs")
      
         #  Now call the usual stacking routines, saving the sky frames for 
         #  all off-source pairs. In the following set of calls p1,p2 are 
         #  the off-source frames, originally p3,p4 and p5,p6 in 'crd_pairs'.
      
         list1 = "" ; list1 = "crdlist"
         while ( fscan ( list1, p1, p2 ) != EOF )   {
            p_sky1   ( "idf", p1, p2 ) 
            if ( ! fixoffsets ) {
               p_dither ( "isx", p1, p2 )
            }
            p_stk1   ( p1, p2 )
            p_objmask2( p1, p2 )
            p_skysub ( p1, p2 ) 
         }
      
         #  Now call a special sky subtraction routine that expects the two 
         #  off-source sky frames 'sky_000p3' and 'sky_000p5' to exist. They
         #  do, because 'p_sky1' was just run on all the off-source pairs.
         
         #   NEED WORK HERE  'p_skysub' has also created 'sky_000p3_000p4'
         #   as well as 'sky_000p5_000p6'. So could use either one in 'p_sky3'.
         #   In general the 'sky_000p3_000p4'-type should be better because 
         #   the stars have been masked out.  
      
         list1 = "" ; list1 = "crd_pairs"
         while ( fscan ( list1, p1, p2, p3, p4, p5, p6 ) != EOF )   {
      
            print ( p1, p2, p3, p4, p5, p6)
            p_sky3 ( p1, p2, p3, p4, p5, p6 ) 
            if ( ! fixoffsets ) {
               p_dither ( "isx", p1, p2 )
            }
            if (dodistcor) {
               p_distcor ( "mcp", "mcd", p1, p2 )
               p_distcor ( "isx", "isd", p1, p2 )
               # Added this to create distortion corrected variance maps
               if (dosigma) {
                  p_distcor ( "var", "vad", p1, p2 )
               }
            }
 
            p_stack ( p1, p2, "test_"//p1//"_"//p2 ) 
            if (dosigma) p_stack_var (p1, p2, "test_"//p1//"_"//p2)
#           p_hchen ( "comblist_test_"//p1//"_"//p2, "chen_"//p1//"_"//p2 )
      
         }
      } else {}
   } else {}


#   Do stacks of all standard stars.

   if (std)    {
      if ( access ( "std_pairs" ))   {

      k = 0

      list1 = "" ; list1 = "std_pairs"
      while ( fscan ( list1, p1, p2, p3, p4 ) != EOF ) {

         k += 1
         if ( k <= 1 )   {
            p_get_date ( "idf", p3 )
            date = p_get_date.output
            pclear ( "ngt_"//date )
         }

         #  If 'sky_p3_p4' is needed, create it or recreate it:
 
         padindex(p3) ; onumber3 = padindex.output
         padindex(p4) ; onumber4 = padindex.output
 
         sky = "sky_"//onumber3//"_"//onumber4//".fits"
 
         if ( !access ( sky ))   {
 
            p_mskedge ( p3, p4 )
            p_sky1   ( "idf", p3, p4 ) 
            p_dither ( "isx", p3, p4 )
            p_stk1   ( p3, p4 )
            p_objmask2( p3, p4 )
            p_skysub ( p3, p4 ) 
 
         } else { }
 
         p_mskedge ( p1, p2 )
         p_sky2 ( p1, p2, p3, p4 ) 
         if ( ! fixoffsets ) {
            p_dither ( "isx",p1, p2 )
         }
         p_stk1 ( p1, p2 )
         p_std ( p1, p2 )
      }

   } else { }

   }  else  { }

end
