procedure p_3go ( flag )

string flag
struct *list1
struct *list2

#  Inserts zmags into stack headers
#
#  Decode 'flag' to process:
#
#  u      uncrowded frames
#  c      crowded frames
#  s      standard stars
#
#  If any of these flags are set, it is expected that the corresponding 
#  pairs files exist:
#
#   u    'unc_pairs'  should exist
#   c	 'crd_pairs'    "      "  
#   s    'std_pairs'    "      " 

begin
	int nf, i, p1, p2
	bool unc, crd, std
	string date, path_ngt, file_ngt
	string stkstd, stkobj, stack, filter, night
	real ngt, etime, airmass, zmag, dmag_air
	real ha, hb, hc, hd

	path_ngt = "home$panic_files/"
	file_ngt = "night_constant_HABCD"

	unc = no ; crd = no ; std = no
	nf = strlen(flag)
	  for ( i = 1; i <= nf; i += 1 ) 	{

            if ( substr(flag,i,i) == "u") unc = yes 
            if ( substr(flag,i,i) == "c") crd = yes 
            if ( substr(flag,i,i) == "s") std = yes
						}

	pclear ( "ins_pairs" )
#  Uncrowded frame stacks
 
	if(unc)	{
	  if ( access ( "unc_pairs" ))	{

!cat unc_pairs > ins_pairs
					} else {}
		} else {}

#  Crowded frame stacks
 
	if(crd)	{
	  if ( access ( "crd_pairs" ))	{

!cat crd_pairs >> ins_pairs
					} else {}
		} else {}
						   
#  Standard star stacks

	if (std) {

	if ( access ( "std_pairs" ))	{

!cat std_pairs >> ins_pairs
					} else {}

		}  else  { }


	list1 = "" ; list1 = "ins_pairs"
	while ( fscan ( list1, p1, p2 ) != EOF )   {



	stkstd = "stk_std_"//p1//"_"//p2
	stkobj = "stack_test_"//p1//"_"//p2

	if ( access ( stkstd//".fits")) stack = stkstd
	if ( access ( stkobj//".fits")) stack = stkobj

	  keypar(stack,"NIGHT",silent+)
	  night = str(keypar.value)

	  keypar(stack,"FILTER",silent+)
	  filter = str(keypar.value)

	  keypar(stack,"EXPTIME",silent+)
	  etime = real(keypar.value)

	  keypar(stack,"AIRMASS",silent+)
	  airmass = real(keypar.value)

	list2 = "" ; list2 = path_ngt//file_ngt
	while ( fscan ( list2, date, ha, hb, hc, hd ) != EOF )   {

	  if ( night == date && filter == "HA" )  {
	      dmag_air = 0.11*(airmass - 1.0)
	      ngt = ha
						  }

	  if ( night == date && filter == "HB" )  {
	      dmag_air = 0.06*(airmass - 1.0)
	      ngt = hb
						  }

	  if ( night == date && filter == "HC" )  {
	      dmag_air = 0.04*(airmass - 1.0)
	      ngt = hc
						  }

	  if ( night == date && filter == "HD" )  {
	      dmag_air = 0.10*(airmass - 1.0)
	      ngt = hd
						  }
								}

#	Insert zmag into stack headers

	zmag = 20.000 + 1.0857*log(etime) - dmag_air - ngt
	print ( stack,"  ",zmag)

	parkey ( zmag, stack, "ZMAG", add+)


		                                        }			
end

