procedure p_avecomb (filelist,outfile)

#######################################################
#						      #
#  Written by P McCarthy and J Wilson, 8/19/99        #
#  This task P McCarthy and J Wilson, 8/19/99        #
#  This task is called by ave_sky.cl to		      #
#  combine dithers according to the "xoff" and "yoff" #
#  offset values in the header, and to correct for    #
#  quadrant roll off by subtracting the mode.         #
#  This is for first pass dither combine only and     #
#  only operates of files that will be used to create #
#  the object mask- not on files that for production  #
#  of the final images.				      #
#######################################################

struct	  *list2, *lista, *alist, *list
file	  filelist	{prompt="List of input files from ave_sky task"}
file	  outfile	{prompt="Name of output file from ave_sky task"}

begin

# Declarations
  file		offs.dat
  file		afile, brlist
  string	outname, somefile, fitname, fname
  real		newxoff, newyoff
  real		mode1, mode2, mode3, mode4, level
  real		modes1, modes2, modes3, modes4

# -------------  set stdimage = "imt1024"

# Make sure variables are clean
  pclear("offs.dat")
  pclear (outfile)
  pclear ("off.dat")
  pclear ("offs.dat")
  pclear ("afile")
  pclear ("brlist")
  pclear ("surflist") 

# ---------------- ! \rm isq*.fits


# filelist is list of files with same chip and same ref file
	 alist = ""; alist=filelist
	 while (fscan (alist,fname) != EOF) {
         
# Write values of offsets from header to a file for imcombine input

	keypar (fname, "xoff2")
	newxoff = (real(keypar.value)) 
	keypar (fname, "yoff2")
	newyoff = (real(keypar.value))
        print (newxoff, newyoff ,>> "off.dat")

         fitname = substr(fname,5,17) 

# break image into quadrants for mode calculation and subtraction


# put isx files in a list to give back to combine_1st_pass for imcombine
         print("isx_"//fitname, >> "surflist")


# close of while loop
  }

# ----------------   !cat /data/mabel/lcir/scripts/abs off.dat >offs.dat

  print ( "# Absolute ", > "offs.dat" )
!cat off.dat >> offs.dat 

# Combine images
#  imcombine ("@"//"surflist", output=outfile, combine="average", scale="none", project=no, outtype="real", offsets="offs.dat", masktype="badvalue", maskvalue=1., reject="none")
  imcombine ("@"//"surflist", output=outfile, combine="average", scale="none", project=no, outtype="real", offsets="offs.dat", masktype="badvalue", maskvalue=1., reject="pclip", pclip=-0.5, lsigma=4., hsigma=4., nkeep=-2)

# Display combined image
display (outfile, 1, erase+, bor+, fill+, zs+, xmag=1, ymag=1)

# Clean up intermediate files and clear variables
delete ("surflist")
list2 = ""
lista = ""

end
