procedure p_bp_mask ( pre, mask_list, n1, n2 )

string pre, mask_list
int n1, n2

struct *list1

#	'mask_list' is a list of starting and ending 
#	'pre' frame numbers to imcombine to make a frame 
#	from which to compute the nightly mask frame.
#	Its name is then entered in the n1 to n2 'idf' 
#	frame headers. A default mask is retrieved if 
#	the mask cannot be made from the night's data.
#	In the latter case 'mask_list' will be a one-line
#	file:   0   0 
#
#	In general 'pre' should be 'idf' as these will 
#`	produce the best badpixel masks. 

begin

	int nf
	string night, pic

	pclear ( "mask_"//night//".pl" )

	p_long_list ( pre, mask_list )

	pclear ( "out1" ) ; pclear ( "out2" ) ; pclear ( "out3" )

#	Only if 'pre//"_pair_list"' is returned non-empty:

	if ( access ( pre//"_pair_list" )	{

	imcombine("@"//pre//"_pair_list",output="out1",combine="median",scale="mode", zero="none")
	fmedian ( "out1", "out2", xwindow=5, ywindow=5 )
	imarith ( "out1", "-", "out2", "out3" )

	imreplace ( "out3", lower=INDEF, upper=-600, value=25000. )
	imreplace ( "out3", lower=800, upper=INDEF, value=25000. )
	imreplace ( "out3", lower=INDEF, upper=24998, value=0.0 )
	imreplace ( "out3", lower=500., upper=INDEF, value=1.0 )

	display ( "out3", 1, erase+, bor+, zs-, zr-, z1=-1, z2=1 )

	pclear ( "pic" )
	head ( "idf_list_1", nlines=1, > "pic" )

	list1 = "" ; list1 = "pic"
	while ( fscan (list1, pic ) != EOF )	{

	  keypar (pic, "NIGHT", silent+ )
       	  night = keypar.value

	imcopy ( "out3", "mask_"//night//".pl" )
										}

								}  else  {

#	Get mask from default storage area

	mask_path = "home$panic_files/bp_masks/"
	imcopy ( mask_path//"mask_default.pl", "mask_"//night//".pl" )

										 }

#	Now store in all existing 'idf' frame headers

	p_pre_list ( "idf", n1, n2 )

	hedit ( "@"//"idf_list", "BPM","mask_"//night//".pl",update+,add+,verify-)


end
