procedure p_crlast ( p1, p2 )

int p1, p2
struct *list1

#  Makes a 'cosmicrays' pass over the 'is2' frames for the
#  case that nloops = 1. In this case p_fix_cr was not run 
#  on the 'izp' frames in pairs. This sets a high (5-sigma) 
#  threshold for CRs. 

begin
	string frame, frnum, mask, onumber
	real sigma, s5
	int nloops

	padindex(p1) ; onumber = padindex.output
	frame = "is2_"//onumber

	  keypar ( frame, "NLOOPS", silent+ )
	  nloops = int(keypar.value)

	if ( nloops == 1 ) 	{

	p_pre_list ( "is2", p1, p2 )

	list1 = "" ; list1 = "is2_list"
	while ( fscan ( list1, frame ) != EOF )  {

      if ( access ( frame//".fits" ))			{

	  frnum = substr(frame,5,9)

#  These are 'is2' frames so should have median close to zero.

	pclear ( "imstatout" ) ; pclear ( "sig" ) 
     	imstat ( frame, fields="stddev", lower=-200, upper=200, >  "imstatout" )
	tail ( "imstatout", nl=1, > "sig" ) 

	list1 = "" ; list1 = "sig"
	while ( fscan ( list1, sigma) != EOF ) { }
	s5 = 5.*sigma 

	pclear ( "msk1" ) ; pclear ( "msk2" )
	cosmicrays ( frame, frame, thresho=s5, interac-, answer-, crmasks="msk1", fluxrat=10.)
	imar ( frame, "*", -1., frame )
	cosmicrays ( frame, frame, thresho=s5, interac-, answer-, crmasks="msk2", fluxrat=10.)
	imar ( frame, "*", -1., frame )

#  Add the new CR-mask frames into 'mcp' frame 

	mask = "mcp_"//frnum//".pl"
	imarith ( mask, "+", "msk1", mask )
	imarith ( mask, "+", "msk2", mask )
	imreplace ( mask, value=1, lower=1.01, upper=INDEF)
 
							}
					}
			}  else {}
end
	  
