procedure p_fid_c ( p1, p2, p3, p4, p5, p6 )

int p1, p2, p3, p4, p5, p6 
struct *list1

#  Used during the night to loop-combine 'irp'
#  frames, find median sky, subtract it, and 
#  display the first resulting frame for 
#  identifying the fiducial star. Will use 'idf'
#  frames if they exist. This variant uses the 
#  sky frames created for the off-source positions

begin
	string pre, sp1, sp3, sp5, isx_frame
	real xfid, yfid, frm_med, sky_med, ratio

	  padindex(p1); sp1 = padindex.output
	  padindex(p3); sp3 = padindex.output
	  padindex(p5); sp5 = padindex.output

	isx_frame = "isx_"//sp1
        pclear (isx_frame )

	pclear ("sky") 
	if ( access ( "sky_"//sp3//".fits") && access ( "sky_"//sp5//".fits")) {
	  imarith ( "sky_"//sp3, "+", "sky_"//sp5, "sky")
	  imarith ( "sky","/", 2., "sky")
		}  else { 
	psorry ("Off-source sky frame ") 
			}
	
#  In general cannot scale sky frame to median of crowded frame; just subtract. 

	if ( access ("idf_"//sp1//".fits")) {
	  imarith ( "idf_"//sp1, "-", "sky", isx_frame )
	  pre = "idf_" 
						} else {
	  p_loops_combine ( "irp", p1, p2 )
	  imarith ( "icp_"//sp1, "-", "sky", isx_frame ) 
	  pre = "icp_"
						}

        pclear ("init.dat") ; pclear ("slist") 
	display (isx_frame, 1, erase-, bor+, fill+, zs+, xmag=0.5, ymag=0.5)
                                                                                                                      
# 	Use imexam to interactively get approx coords for fiducial star
#	This could be generalized to a list of stars if we wanted to keep 
#	these files of XY values around until pipeline is used. 
                                                                                                                      
        print ( "")
        print ( "  >>>>> Identify a star  ( a  q )  " )
        print ( "")
                                                                                                                      
        imexamine ( isx_frame,1,keeplog+,logfile='slist' )
        !egrep -v '#' slist | awk '{print $1, $2 }' > init.dat

	list1 = "" ; list1 = "init.dat"
	while ( fscan ( list1, xfid, yfid ) != EOF )	{ }

	if ( pre == "icp_" )	{
	  parkey ( xfid, "irp_"//sp1//"_001.fits", "XFID", add+) 
	  parkey ( yfid, "irp_"//sp1//"_001.fits", "YFID", add+)
				} else {
 	  parkey ( xfid, "idf_"//sp1//".fits", "XFID", add+) 
	  parkey ( yfid, "idf_"//sp1//".fits", "YFID", add+)
					}
end
