procedure p_linearize ( camera, n1, n2 )

string camera 
int n1, n2

struct *list1
struct *list2

#  /home/persson/iraf/panic_scripts/p_linearize.cl

#  PANIC (camera = p) or RetroCam (r) linearization script. 
#  Linearizes 'irp' or 'irr' frames n1 through n2, skipping 
#  missing ones, and producing 'izp' or 'izr' frames. Parameters
#  and basic algorithm from Paul Martini.
#  Rev:  30nov2003   SEP
#
#  Set readout time parameters for each camera
#  All times in seconds.
#
#  reads_ep = number of end-point reads
#  pre_ep = number of pre-endpoint reads; set to 1 for all cameras.
#
#  tf = frame readout time
#  td = delay time
#  tfd = tf + td
#
#  ta = acquisition time
#  t_pre_ep = pre-endpoint readout time = pre_ep * tfd 
#  t_read = total effective frame readout time = reads_ep * ( tfd + ta )

begin 
	string pic, readmode

	real exptime, pre_ep, reads_ep, p, delta
	real tf, td, tfd, ta, t_pre_ep, t_read
	real c1, c2, c3, linthresh

	  pre_ep = 1.

   # THis should be in p_1go
	#p_load 

	if ( camera == 'r' || camera == 'R' || camera == 'retro' || camera == 'RetroCam' )	{

	  td = 0.010 ; tf = 2.0 ; ta = 0.085
																				}

	if ( camera == 'p' || camera == 'P' || camera == 'panic' || camera == 'PANIC' )	{

	  td = 0.010 ; tf = 2.0 ; ta = 0.085
          c1 = 4.291443e+01 ; c2 = 9.752524e-01 ; c3 = 1.962545e-06 ; linthresh = 8000.
																				}

	tfd      = tf + td
	t_pre_ep = pre_ep * tfd 

#	Get list of all pictures to be linearized
#	Output is "raw_pic_list"

	p_raw_list ( camera, n1, n2 )

	list1 = "" ; list1 = "raw_pic_list"
	while ( fscan ( list1, pic ) != EOF )	{

     	  keypar (pic, "EXPTIME", silent+ )
       	  exptime = real(keypar.value)

          keypar (pic, "READMODE", silent+)
          readmode = (keypar.value)

	if ( readmode == 'Double' ) reads_ep = 1.
	if ( readmode == 'Quadruple' ) reads_ep = 2.
	if ( readmode == 'Sextuple' ) reads_ep = 3.
	if ( readmode == 'Octuple' ) reads_ep = 4.

	t_read   = reads_ep * ( tfd + ta )

#	Linearize

	delta = ( t_pre_ep + t_read / 2. ) 
	p = delta / ( delta + exptime )	

	p_lincor_sep ( pic, p, c1, c2, c3, linthresh )
								}


end
