procedure p_rego ( n1, n2, flag )

int n1, n2
string flag
struct *list1

#	USED ONLY TO REREDUCE ALL PANIC SNE DATA

#  PANIC pipeline for galaxies, standard stars, and 
#  crowded field data.
#  For galaxy data typically square-9 dithers were used.
#  For standard stars typically dice-5 dithers were used. 
#  For crowded fields special sky-creation routines are used;
#    the object data frames themselves are not used.  
#
#  Decode 'flag' to process:
#
#  n      routines that apply to all frames in the night, n1 - n2
#  u      uncrowded frames, e.g., LCIRS galaxies - square-9 dithers
#  c      crowded frames, e.g., rich starfields with separate skies 
#  s      standard stars - dice-5 dithers
#
#  If any of these flags are set, it is expected that the corresponding 
#  pairs files exist:
#
#   u    'unc_pairs'  should exist
#   c	 'crd_pairs'    "      "  
#   s    'std_pairs'    "      " 

begin
	int nf, i, p1, p2, p3, p4
	bool naf, unc, crd, std
	string onumber, date

	naf = no ; unc = no ; crd = no ; std = no
	nf = strlen(flag)
	  for ( i = 1; i <= nf; i += 1 ) 	{
            if ( substr(flag,i,i) == "n") naf = yes 
            if ( substr(flag,i,i) == "u") unc = yes 
            if ( substr(flag,i,i) == "c") crd = yes 
            if ( substr(flag,i,i) == "s") std = yes
						}

#  These are the procedures that apply to all frames

	if(naf) {

#	  p_linearize ( "p", n1, n2 )

	  p_loops_combine  ( "izp", n1, n2 )            
#	  p_dark ( n1, n2 )
	  p_subdk ( n1, n2 )

	if ( access ( "dflat_pairs" ))	{
	list1 = "" ; list1 = "dflat_pairs"
	while ( fscan ( list1, p1, p2 ) != EOF ) {
	  p_dflat ( p1, p2 )
						 }
					} else {}

#
#	if ( access ( "tflat_pairs" ))	{
#	list1 = "" ; list1 = "tflat_pairs"
#	while ( fscan ( list1, p1, p2 ) != EOF ) {
#	  p_tflat ( p1, p2 )
#						 }
#					} else {}
#
	  p_defaults ( n1 )
	  p_flatten ( n1, n2 )

	}  else  { }

print (unc)

#  Done with procedures that apply to all frames in the night or run.
#  Dealing with 'idf' frames from now on. 
#
#  Do uncrowded frame (e.g. faint galaxy) stacks

	if(unc)	{
	  if ( access ( "unc_pairs" ))	{

	list1 = "" ; list1 = "unc_pairs"
	while ( fscan ( list1, p1, p2 ) != EOF )   {

	  p_mskedge ( p1, p2 )
	  p_sky1   ( "idf", p1, p2 ) 
	  p_dither ( "isx", p1, p2 )
	  p_stk1   ( p1, p2 )
	  p_objmask( p1, p2 )
	  p_skysub ( p1, p2 ) 	# Now have 'is2' frames with correct associated 'mcp' mask frames.
				# Now want to correct 'is2' and 'mcp' frames for distortion.
				# These become        'isd' and 'mcd' frames. 

	  p_distcor ( "mcp", "mcd", p1, p2 )
	  p_distcor ( "is2", "isd", p1, p2 )

				# The BPM header parameter in 'isd' is now 'mcd'  

	  p_stack  ( p1, p2, "test_"//p1//"_"//p2 ) 
#	  p_hchen  ( "comblist_test_"//p1//"_"//p2, "chen_"//p1//"_"//p2 )
						   }
					} else {}
		} else {}

end
