procedure p_variance ( n1, n2 )

int n1, n2

#  Produce a variance map for each idf*.fits file.  Also adds a header keyword
#  called VARIANCE to each idf file.  These can be used later to construct the
#  noise map for the dither sequence.

begin
   string var_frame, idf_frame, onumber
   real egain, gain, nloops

   for ( i = n1 ; i <= n2; i += 1 ) {

      padindex(i) ; onumber = padindex.output ; 
      idf_frame = "idf_"//onumber//".fits"
      var_frame = "var_"//onumber//".fits"
      pclear(var_frame)

      if ( access ( idf_frame ))  {
         print("doing file "//idf_frame)
         # variance is (sky + object)/gain, so just idf*.fits/gain
         keypar(idf_frame, "EGAIN", silent+)
         egain = real(keypar.value)
         keypar(idf_frame, "NLOOPS", silent+)
         nloops = real(keypar.value)

         gain = egain*nloops
         imarith(idf_frame, "/", gain, var_frame)
         # Save the file name in the header
         hedit(idf_frame,"VARIANCE",var_frame,add+,update+,verify-)
      }
   }
end















