#!/usr/bin/env python

import sys,os,string
from FITS import FITS
from FITS import qread
from glob import glob
import re
import Numeric as num

if len(sys.argv) > 1:
   prefix = sys.argv[1]
else:
   prefix = "./"

name_pat1 = re.compile('idf_([0-9]+).fits')
name_pat2 = re.compile('isx_([0-9]+)')
x_refs = {}
y_refs = {}

list = glob('idf*.fits*')
for file in list:
   print file
   f = FITS(file)
   if f['OBSTYPE'] == "standard":
      filenum = int(name_pat1.findall(file)[0])
      try:
         ref = int(name_pat2.findall(f['REFERENC'])[0])
      except:
         continue
      if filenum == ref:
         try:
            x_refs[filenum] = float(f['XFID'])
            y_refs[filenum] = float(f['YFID'])
         except:
            print "Error, fiducial star not found for ", file
      xfid = x_refs[ref]
      yfid = y_refs[ref]

      x = int(xfid - f['XOFF'])
      y = int(yfid - f['YOFF'])
      list2 = glob('%sirp_%05d_*.fits*' % (prefix,filenum))
      for file2 in list2:
         data = qread(file2)[y-100:y+101,x-100:x+101]
         max = num.maximum.reduce(num.maximum.reduce(data))
         print file2,x,y,max
   f.close()
