from pclear import pclear
from pyraf import iraf
import myiraf

def p_avecomb(filelist, outfile):
   '''   
      Written by P McCarthy and J Wilson, 8/19/99
      This task P McCarthy and J Wilson, 8/19/99
      This task is called by ave_sky.cl to
      combine dithers according to the "xoff" and "yoff"
      offset values in the header, and to correct for
      quadrant roll off by subtracting the mode.
      This is for first pass dither combine only and
      only operates of files that will be used to create
      the object mask- not on files that for production
      of the final images.
   '''

   # Make sure variables are clean
   pclear("offs.dat")
   pclear (outfile)
   pclear ("surflist") 

   # filelist is list of files with same chip and same ref file
   f1 = open('offs.dat', 'w')
   print >> f1, "# Absolute "
   f2 = opne('surflist', 'w')
   for fname in filelist:
      # Write values of offsets from header to a file for imcombine input
      newxoff = myiraf.get_header(fname, "xoff2", float)
      newyoff = myiraf.get_header(fname, "yoff2", float)
      print >> f1, newxoff, newyoff
      print >> f2, "isx_"+fname[4:]

   f1.close()
   f2.close()

   # Combine images
   iraf.imcombine("@surflist", output=outfile, combine="average", scale="none",
        project=no, outtype="real", offsets="offs.dat", masktype="badvalue", 
        maskvalue=1., reject="none")

   # Display combined image
   iraf.display(outfile, 1, erase=1, bor=1, fill=1, zs=1, xmag=1, ymag=1)

   # Clean up intermediate files and clear variables
   pclear("surflist")
   pclear("offs.dat")
