def p_lincor_sep (pic, p, c1, c2, c3, linthresh):
   #   Do linearity correction for an image
   #
   #   p = a/(a + exptime), where a is the overhead due
   #   to prereads and reads. The output image is
   #   [(1+p)*pic](corr) - [p*pic](corr)
   #
   #  The linearity correction is a polynomial above a 
   #  threshold. 

   #imarith.pixtype = "real"
   #imarith.calctype = "real"
   #pclear ( "in" ) ; pclear ( "out1" ) ; pclear ( "out2" )

   p1 = 1. + p

   #	A note on strings
   #
   #	strlen("123456")  returns 6
   #	
   #	substr("123456",3,5) returns 345
   #	substr("123456",3,8) returns 3456

  	output = "izp_"//substr(pic,5,25)
	pclear ( output )

# Check that the input is present

  if (!access(pic)) { 
    print(" LINCOR: Error, image ",pic," not found")
    clbye()
  }
		
  imarith ( pic, "*", p1, "in" )



  imcalc("in", "out1", equals="if im1 .le. "//linthresh//" then im1 else "//c1//" + "//c2//"*im1 +  "//c3//"*sqr(im1)", pixtype="old", verbose- )

#	imarith ( "in", "+", "out1", "out1" ) ; imarith ("out1", "-", "in", "out1" )

  pclear ( "in" )
  imarith ( pic, "*", p, "in" )



  imcalc("in", "out2", equals="if im1 .le. "//linthresh//" then im1 else "//c1//" + "//c2//"*im1 +  "//c3//"*sqr(im1)", pixtype="old", verbose- )

#	imarith ( "in", "+", "out2", "out2" ) ; imarith ("out2", "-", "in", "out2" )

  imarith ( "out1", "-", "out2", output )
  chpixtype ( output, output, newpixtyp="short" )

end
