#include <stdio.h>
#include <stdlib.h> 
#include <string.h>
#include <math.h>
#include "/usr/local/include/fitsio.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/fitshead.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/fitsfile.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/wcs.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/lwcs.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/wcscat.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/wcslib.h"
#include "/home/phantom/hchen/lcir/wcstools-2.6.8/libwcs/imio.h"

#define PS 0.125
#define NSTACK 50
#define M 7
#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;
static float sqrarg;
#define SQR(a) ((sqrarg=(a)) == 0.0 ? 0.0 : sqrarg*sqrarg) 
#define incred 200
#define flength 9
#define pi 3.1415926
#define GN 1.6
#define RN 20.0
#define MAX 40000
#define max 100.0

#define border 100
#define MSPEAK 1.0
#define SATUR 280.0
#define nstar 200
#define tol 20

void printerror( int status);
void readin(char []);
long round(float);
void weight(float [],float []);
void sort(unsigned long, float *);
float med( float *, long *);
float sigmed( float *, long *);

void getdim(int *,int *,int [][]);
void combine(int *, int *, int[][], float[], float[], char []);
void crclip(float [],float [],int [], int *);
int zcount(float [], float [], int *);

int hdu[200],xdim[200],ydim[200],nf,tr[200][5],ch,bx,by,BD;
long ndr,coadd[200];
float off[200][3],t[200],pfl[200],pz[200],x[200],y[200],gn,rn;
float zpoff[200],theta[200],sclip,psc;
char ffname[200][60], expt[20];

main(int argc, char **argv)
{
  fitsfile *fptr;
  int status,ii,jj,nfound,hdutype,anynull,shift[200][3],xd,yd,ck,cc;
  char comment[80],data[20];
  float meds[200], medd[200], nullval;

  if(argc!=7)
    {
      printf("stack3c inlist out_image sigma_clip blk_x blk_y border-width\n");
      exit(1);
    }
  else
    {
      bx=atoi(argv[4]); by=atoi(argv[5]);
      readin(argv[1]); sclip=atof(argv[3]);
      BD=atoi(argv[6]); 
      weight(medd,meds);
      getdim(&xd,&yd,shift);          
      combine(&xd,&yd,shift,medd,meds,argv[2]);

      return 0;
    }
}

void readin(char imlist[])
{
  FILE *inlist;
  char data[200],*data1=data+6,*data2=data+16,*endptr;
  int i,j;
  float ra[200],dec[200],offx0,offy0;

  if ( (inlist=fopen(imlist,"r")) == NULL )
    {
      printf("Cann't open file %s\n",imlist);
      exit(1);
    }
  i=0;
  while(fgets(data,200,inlist)!=NULL)
    {
      i++;
      ra[i]=strtod(data2,&endptr);
      dec[i]=strtod(endptr,&endptr);
      off[i][1]=strtod(endptr,&endptr)*(float)bx;
      off[i][2]=strtod(endptr,&endptr)*(float)by;
      if(i==1)
        {
          offx0=off[i][1]; offy0=off[i][2];
        }
      for(j=flength;j<strlen(data1);j++) data1[j]=(char)NULL;
      strcpy(ffname[i],data1);
      printf("%s\n",ffname[i]);
      off[i][1]=off[i][1]-offx0;
      off[i][2]=off[i][2]-offy0;
      printf("%8.2lf%8.2lf\n",off[i][1],off[i][2]);
    }
  nf=i;
  fclose(inlist);
}

void weight(float medd[200], float meds[])
{
  FILE *list;
  fitsfile *fptr;
  char comment[80],data[200],filename[200],image[80],*endptr,*dat=data+3;
  int status, k, nfound, hdutype, anynull, j, i, jj,nn;
  long fpixel, imsize,l,ll,naxes[2],kk,ii;
  float nullval,*errd[1200],*errs[1200],rowdata1[2400],rapx[200],decpx[200];
  float medf,*p,*q,check,exptime,a1,a2,a3,a4,ra[200],dec[200],offx0,offy0; 
  int naxis=2,axlen[7],dtype=6,ier,len_image=79,mode=1,ima,bitpix=FLOAT_IMG;
 
  for(k=1;k<=nf;k++)
    {
      strcpy(data,ffname[k]);
      sprintf(filename,"%s.fits",data);
      filename[strlen(filename)]=(char)NULL;
      /* strcpy(filename,data); */
      printf("open file %s\n",filename);
      status=0; fpixel=1; 
      if ( fits_open_file(&fptr, filename, READONLY, &status) ) 
        printerror( status );
      if(fits_read_keys_lng(fptr, "NAXIS", 1, 2, naxes, &nfound, &status))
        printerror( status );
      printf("x[%d]=%6d\n",k,naxes[0]);
      printf("y[%d]=%6d\n",k,naxes[1]);
      if ( fits_read_key_flt(fptr,"EXPTIME",&exptime,comment,&status) )
        printerror( status );
      if ( fits_read_key_lng(fptr,"NCOMBINE",&ll,comment,&status) )
        printerror( status );
      t[k]=exptime; coadd[k]=ll;
      printf("t[%d]=%6.1lf\n",k,t[k]*(float)coadd[k]);
      xdim[k]=naxes[0]; ydim[k]=naxes[1];
      printf("xdim[%d]=%d, ydim[%d]=%d\n",k,xdim[k],k,ydim[k]);
      tr[k][1]=1+BD;
      tr[k][2]=bx*xdim[k]-BD;
      tr[k][3]=1+BD;
      tr[k][4]=by*ydim[k]-BD;

      for(i=0;i<xdim[k];i++)
        {
          errd[i]=(float *) calloc((ydim[k]), sizeof(float)); 
          errs[i]=(float *) calloc((ydim[k]), sizeof(float)); 
        }
      imsize=xdim[k]; 
      for(j=0;j<ydim[k];j++)
        {
          if(fits_read_img(fptr,TFLOAT,fpixel,imsize,&nullval,rowdata1,&anynull,&status))
            printerror( status );
          for(i=0;i<xdim[k];i++) errd[i][j]=rowdata1[i];
          fpixel=fpixel+imsize;
        }
      for(j=0;j<strlen(filename);j++) filename[j]=(char)NULL;
      if ( fits_close_file(fptr, &status) ) 
        printerror( status ); 

      p=(float *) calloc((1024*1024), sizeof(float));
      ll=0;
      for(j=11;j<509;j++)
        for(i=11;i<509;i++)
          if(fabs(errd[i][j])<max)
            {
              ll++;
              p[ll]=errd[i][j];
            }
      a1=med(p,&ll);
     
      ll=0;
      for(j=514;j<ydim[k]-11;j++)
        for(i=11;i<509;i++)
          if(fabs(errd[i][j])<max)
            {
              ll++;
              p[ll]=errd[i][j];
            }
      a2=med(p,&ll);

      ll=0;
      for(j=11;j<509;j++)
        for(i=514;i<xdim[k]-11;i++)
          if(fabs(errd[i][j])<max)
            {
              ll++;
              p[ll]=errd[i][j];
            }
      a3=med(p,&ll);

      ll=0;
      for(j=514;j<ydim[k]-11;j++)
        for(i=514;i<xdim[k]-11;i++)
          if(fabs(errd[i][j])<max)
            {
              ll++;
              p[ll]=errd[i][j];
            }
      a4=med(p,&ll);

      sprintf(filename,"idf%s.fits",dat);
      filename[strlen(filename)]=(char)NULL;
      printf("open file %s\n",filename);
      status=0; fpixel=1; 
      if ( fits_open_file(&fptr, filename, READONLY, &status) ) 
        printerror( status );
      for(j=0;j<ydim[k];j++)
        {
          if(fits_read_img(fptr,TFLOAT,fpixel,imsize,&nullval,rowdata1,&anynull,&status))
            printerror( status );
          for(i=0;i<xdim[k];i++) 
            if((rowdata1[i]>0.0) && (rowdata1[i]<MAX))
              errs[i][j]=sqrt(GN*rowdata1[i])/sqrt((float)coadd[k])/GN;
            else
              errs[i][j]=0.0;
          fpixel=fpixel+imsize;
        }
      for(j=0;j<strlen(filename);j++) filename[j]=(char)NULL;
      if ( fits_close_file(fptr, &status) ) 
      printerror( status ); 
      printf("finish reading the image\n");

      for(j=0;j<ydim[k];j++)
	for(i=0;i<xdim[k];i++)
	  {
	    if((i>=509)&&(i<=513)) errs[i][j]=0.0;
	    if((j>=509)&&(j<=513)) errs[i][j]=0.0;
	  }
 
      /* block replicating the images */

      sprintf(filename,"bss%s.fits",dat);
      filename[strlen(filename)]=(char)NULL;
      printf("creat file %s\n",filename);
      status=0; fpixel=1; imsize=xdim[k]*bx;
      remove(filename);
      if (fits_create_file(&fptr, filename, &status)) 
        printerror( status );      
      naxes[0]=xdim[k]*bx;
      naxes[1]=ydim[k]*by;
      if (fits_create_img(fptr,bitpix,naxis,naxes, &status) )
        printerror( status );
      for(j=0;j<ydim[k];j++)
        {
          for(i=0;i<xdim[k];i++) 
            for(ii=1;ii<=bx;ii++)
              {
                ll=bx*i+(ii-1); 
                if((i<512)&&(j<512))
                  rowdata1[ll]=errd[i][j]-a1;
                else if ((i<512)&&(j>=512))
                  rowdata1[ll]=errd[i][j]-a2;
                else if ((i>=512)&&(j<512))
                  rowdata1[ll]=errd[i][j]-a3;
                else if ((i>=512)&&(j>=512))
                  rowdata1[ll]=errd[i][j]-a4;
              }
          for(jj=1;jj<=by;jj++)
            {
              if ( fits_write_img(fptr,TFLOAT,fpixel,imsize,rowdata1,&status) )
                printerror( status );            
              fpixel=fpixel+imsize;
            }
        }
      for(j=0;j<strlen(filename);j++) filename[j]=(char)NULL;
      if ( fits_close_file(fptr, &status) ) 
      printerror( status ); 
      
      sprintf(filename,"bdf%s.fits",dat);
      filename[strlen(filename)]=(char)NULL;
      printf("creat file %s\n",filename);
      status=0; fpixel=1; imsize=xdim[k]*bx;
      remove(filename);
      if (fits_create_file(&fptr, filename, &status)) 
        printerror( status );      
      naxes[0]=xdim[k]*bx;
      naxes[1]=ydim[k]*by;
      if (fits_create_img(fptr,bitpix,naxis,naxes, &status) )
        printerror( status );
      for(j=0;j<ydim[k];j++)
        {
          for(i=0;i<xdim[k];i++) 
            for(ii=1;ii<=bx;ii++)
              {
                ll=bx*i+(ii-1); 
                rowdata1[ll]=errs[i][j];
              }
          for(jj=1;jj<=by;jj++)
            {
              if ( fits_write_img(fptr,TFLOAT,fpixel,imsize,rowdata1,&status) )
                printerror( status );            
              fpixel=fpixel+imsize;
            }
        }
      for(j=0;j<strlen(filename);j++) filename[j]=(char)NULL;
      if ( fits_close_file(fptr, &status) ) 
      printerror( status );       

      q=(float *) calloc((1024*1024), sizeof(float));
      ll=0;
      for(i=(xdim[k]/2-500);i<(xdim[k]/2+500);i++)
        for(j=(ydim[k]/2-500);j<(ydim[k]/2+500);j++)
          if(fabs(errd[i][j])<max)
            {
              if((i<509)&&(j<509))
		{
		  ll++;
		  p[ll]=errd[i][j]-a1;
		  q[ll]=errs[i][j];
		}
              else if ((i<509)&&(j>=514))
		{
		  ll++;
		  p[ll]=errd[i][j]-a2;
		  q[ll]=errs[i][j];
		}
              else if ((i>=514)&&(j<509))
		{
		  ll++;
		  p[ll]=errd[i][j]-a3;
		  q[ll]=errs[i][j];
		}
              else if ((i>=514)&&(j>=514))
		{
		  ll++;
		  p[ll]=errd[i][j]-a4;
		  q[ll]=errs[i][j];
		}
            } 
      nn=(int)ll;
      medd[k]=med(p,&ll);
      meds[k]=med(q,&ll);
      ll=0;
      for(l=1;l<=nn;l++) 
        if(fabs(p[l]-medd[k])<(5.0*meds[k])) 
          {
            ll++;
            p[ll]=p[l];
            q[ll]=fabs(p[l]-medd[k]);
          }
      medd[k]=med(p,&ll);
      meds[k]=med(q,&ll)/t[k]; 
      free(p); free(q);
      printf("im%d has median sky %8.6lf +/- %8.6lf based on %d pixels\n",k,medd[k],meds[k],nn);
      for(i=0;i<xdim[k];i++) { free(errd[i]); free(errs[i]); }
    }

}

void getdim(int *xd, int *yd, int shift[200][3])
{
  int k,imlx,imly,imux,imuy,mx,my,nx[200],ny[200];
  float lx,ux,ly,uy;

  lx=0.; ux=0.; ly=0.; uy=0.;
  for(k=1;k<=nf;k++)
    {
      if(off[k][1]<lx) { lx=off[k][1]; imlx=k; }
      if(off[k][1]>ux) { ux=off[k][1]; imux=k; }
      if(off[k][2]<ly) { ly=off[k][2]; imly=k; }
      if(off[k][2]>uy) { uy=off[k][2]; imuy=k; }
    }
 
  for(k=1;k<=nf;k++)
    {
      shift[k][1]=round(off[k][1]-lx);  nx[k]=bx*xdim[k]+shift[k][1];
      shift[k][2]=round(off[k][2]-ly);  ny[k]=by*ydim[k]+shift[k][2];
      printf("image %d x_shift=%d, y_shift=%d\n",k,shift[k][1],shift[k][2]);
    }
  mx=0; my=0;
  for(k=1;k<=nf;k++)
    {
      if(nx[k]>mx) mx=nx[k];
      if(ny[k]>my) my=ny[k];
    }
  (*xd)=mx; (*yd)=my;
  printf("x_dim=%d, y_dim=%d\n",(*xd),(*yd));
}

void combine(int *xd,int *yd,int shift[200][3],float medd[200],float meds[],char oimage[])
{
  FILE *list;
  fitsfile *fptr,*ofptrd,*ofptrs;
  long fpixel[200], imsize, index[200], l, ll, fp, naxis=2, naxes[2],nn;
  float dat[200],sig[200],psig,dom,*outd[4096],*outs[4096],mmd[200],isig,mf;
  float nullval,*imd[200],*imds[200],p[200],s[200],idat,kra,kdec,kexp,kpsc;
  float rowdata1[4096],*sky[200],check,zmed[200],sflat[512],kgain,kequinox;
  char kobj[80],kfilter[80],kinstrument[80],ktele[80],*imhead,*impics;
  char comment[80],data[200],filename[200],image[80],sigma[80],*data1=data+3;
  int i,j,k,status,nfound,hdutype,anynull,ii,flag[200],ima,imas,jj,yi,yf;
  int num,nrow,morekeys,bitpix=FLOAT_IMG,nd,length,nb;
 
  status=0;
  strcpy(data,ffname[1]);
  sprintf(filename,"idf%s.fits",data1);
  filename[strlen(filename)]=(char)NULL;
  printf("open file %s\n",filename);
  kexp=1.0; 
  if ( fits_open_file(&fptr, filename, READONLY, &status) ) 
    printerror( status );
  if ( fits_read_key_flt(fptr,"RA",&kra,comment,&status) )
    printerror( status );
  if ( fits_read_key_flt(fptr,"DEC",&kdec,comment,&status) )
    printerror( status );
  if ( fits_read_key_flt(fptr,"EGAIN",&kgain,comment,&status) )
    printerror( status );
  if ( fits_read_key_flt(fptr,"EQUINOX",&kequinox,comment,&status) )
    printerror( status );
  if ( fits_read_key_flt(fptr,"SCALE",&kpsc,comment,&status) )
    printerror( status ); 
  kpsc=0.5*kpsc;
  if ( fits_read_key_str(fptr,"OBJECT",kobj,comment,&status) )
    printerror( status );
  if ( fits_read_key_str(fptr,"FILTER2",kfilter,comment,&status) )
    printerror( status );
  if ( fits_read_key_str(fptr,"INSTRUME",kinstrument,comment,&status) )
    printerror( status );
  if ( fits_read_key_str(fptr,"TELESCOP",ktele,comment,&status) )
    printerror( status );
  if ( fits_close_file(fptr, &status) ) 
    printerror( status );      

  sprintf(image,"%s.fits",oimage);
  image[strlen(image)]=(char)NULL;
  sprintf(sigma,"%s_sig.fits",oimage);
  sigma[strlen(sigma)]=(char)NULL;
  printf("%s,%d-%d\n",image,(*xd),(*yd));
  status=0;
  remove(image); remove (sigma);
  if (fits_create_file(&ofptrd, image, &status)) 
    printerror( status );      
  if (fits_create_file(&ofptrs, sigma, &status)) 
    printerror( status );      
  naxes[0]=(*xd);
  naxes[1]=(*yd);
  if (fits_create_img(ofptrd,bitpix,naxis,naxes, &status) )
    printerror( status );
  if (fits_create_img(ofptrs,bitpix,naxis,naxes, &status) )
    printerror( status );

  if ( fits_write_key(ofptrd,TSTRING,"OBJECT",kobj,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TSTRING,"FILTER",kfilter,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TSTRING,"INSTRUME",kinstrument,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TSTRING,"TELESCOP",ktele,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TSTRING,"CTYPE1","RA---TAN",comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TSTRING,"CTYPE2","DEC--TAN",comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"RA",&kra,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"DEC",&kdec,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"EQUINOX",&kequinox,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"CDELT1",&kpsc,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"CDELT2",&kpsc,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"EXPTIME",&kexp,comment,&status) )
    printerror( status );
  if ( fits_write_key(ofptrd,TFLOAT,"GAIN",&kgain,comment,&status) )
    printerror( status );
  
  printf("start forming final images\n");
  for(i=0;i<(*xd);i++)
    {
      outd[i]=(float *) calloc(((*yd)+1), sizeof(float));
      outs[i]=(float *) calloc(((*yd)+1), sizeof(float));
    }

  num=(int)((float)(*yd)/(float)incred);
  printf("there are %d subimages\n",num+1);
  status=0; 
  for(k=1;k<=nf;k++) fpixel[k]=1;

  for(jj=1;jj<=(num+1);jj++)
    {
      yi=1+incred*(jj-1); 
      if(jj==(num+1)) yf=(*yd);
      else yf=incred*(jj);
      for(k=1;k<=nf;k++)
	{
	  if((shift[k][2]<yf) && ((by*ydim[k]+shift[k][2])>=yi))
	    {
	      if((shift[k][2]<yi) && ((by*ydim[k]+shift[k][2])>=yf))
		nrow=yf-yi+1;
	      else if((shift[k][2]>=yi) && ((by*ydim[k]+shift[k][2])>=yf))
		nrow=yf-shift[k][2];
	      else if((shift[k][2]<yi) && ((by*ydim[k]+shift[k][2])<yf))
		nrow=by*ydim[k]+shift[k][2]-yi+1;
	      else 
		{
		  printf("unknown conditions in (%d,%d) for image %d\n",yi,yf,k);
		  exit(1);
		}
	      imsize=(long)(bx*xdim[k]*nrow);
	      imd[k]=(float *) calloc((imsize), sizeof(float));
	      imds[k]=(float *) calloc((imsize), sizeof(float));

	      strcpy(data,ffname[k]);
	      sprintf(filename,"bss%s.fits",data1);
	      filename[strlen(filename)]=(char)NULL;
	      printf("open file %s\n",filename);
	      if ( fits_open_file(&fptr, filename, READONLY, &status) ) 
		printerror( status );
	      if(fits_read_img(fptr,TFLOAT,fpixel[k],imsize,&nullval,imd[k],&anynull,&status))
		printerror( status );	      
              if ( fits_close_file(fptr, &status) ) 
                printerror( status );      
	      for(j=0;j<strlen(filename);j++) filename[j]=(char)NULL;

	      sprintf(filename,"bdf%s.fits",data1);
	      filename[strlen(filename)]=(char)NULL;
	      printf("open file %s\n",filename);
	      if ( fits_open_file(&fptr, filename, READONLY, &status) ) 
		printerror( status );
	      if(fits_read_img(fptr,TFLOAT,fpixel[k],imsize,&nullval,imds[k],&anynull,&status))
		printerror( status );	      
              if ( fits_close_file(fptr, &status) ) 
                printerror( status );      

	      ll=fpixel[k]-1;
              for(l=0;l<imsize;l++)
		if((imd[k][l]+500.0)>0.0)
		  {
		    imds[k][l]=imds[k][l];
		    imd[k][l]=imd[k][l]; 
		  }
		else
		  {
		    imd[k][l]=0.0; imds[k][l]=0.0;
		  }
	      for(j=0;j<strlen(filename);j++) filename[j]=(char)NULL;
	      fpixel[k]=fpixel[k]+imsize;
	    }
	}
      for(k=1;k<=nf;k++) index[k]=0; 

      for(j=yi;j<=yf;j++)
	{
	  for(i=0;i<(*xd);i++)
	    {
	      nd=0;
	      for(k=1;k<=nf;k++) 
		{
		  if((shift[k][2]<yf) && ((by*ydim[k]+shift[k][2])>=yi))
		    {
		      if((j<=shift[k][2]) || (j>(shift[k][2]+by*ydim[k])))
			{ 
			  dat[k]=0.0; sig[k]=0.0; l=1;
			}
		      else if((i<shift[k][1]) || (i>=(shift[k][1]+bx*xdim[k])))
			{
			  dat[k]=0.0; sig[k]=0.0; l=1;
			}
		      else
			{
			  if((j<=(shift[k][2]+tr[k][3]-1)) || (j>(shift[k][2]+tr[k][4])))
			    {
			      dat[k]=0.0; sig[k]=0.0; l=1;
			    }
			  else if((i<(shift[k][1]+tr[k][1]-1)) || (i>=(shift[k][1]+tr[k][2])))
			    {
			      dat[k]=0.0; sig[k]=0.0; l=1;
			    }
			  else
			    {
			      l=index[k];
			      if(imd[k][l]>MAX) 
				{
				  dat[k]=0.0; sig[k]=0.0;
				}
			      else 
				{
				  dat[k]=imd[k][l]-medd[k]; sig[k]=imds[k][l];
				}
			    }
			  index[k]=index[k]+1;
			
			  /* nn=l/xdim[1];
			     nn=l-nn*xdim[1]+1; */
			  nd++;
			  p[nd]=dat[k]/t[k]; 
			  s[nd]=sig[k]/t[k]; 
			  mmd[nd]=meds[k];
			}
		    }
		}
	      ll=nd;
              crclip(p,mmd,flag,&nd);
              psig=0;
              for(k=1;k<=nd;k++) 
                psig = psig + flag[k];
              idat=0.0; dom=0.0; isig=0.0;
              if(psig != 0)
                {
                  for(k=1;k<=nd;k++)
                    if (flag[k] != 0)
                      {
                        idat=idat+p[k]/SQR(mmd[k]);
                        isig=isig+SQR(s[k])/SQR(mmd[k])/SQR(mmd[k]);
                        dom=dom+1.0/SQR(mmd[k]);
                      }
                  idat=idat/dom;
                  isig=sqrt(isig)/dom;
                }
              else
                idat=med(p,&ll); 
              outd[i][j]=idat;
              outs[i][j]=isig;
	    }
	}
      for(k=1;k<=nf;k++)
	if((shift[k][2]<yf) && ((by*ydim[k]+shift[k][2])>=yi))
	  { free(imd[k]); free(imds[k]); }
    }
  fp=1; imsize=(*xd);
  for(j=1;j<=(*yd);j++)
    {
      for(i=0;i<(*xd);i++) rowdata1[i]=outd[i][j];
      if ( fits_write_img(ofptrd,TFLOAT,fp,imsize,rowdata1,&status) )
        printerror( status );    
      fp+=imsize;
    }
  fp=1; imsize=(*xd);
  for(j=1;j<=(*yd);j++)
    {
      for(i=0;i<(*xd);i++) 
	if(outs[i][j]!=0.0) rowdata1[i]=outs[i][j];
	else rowdata1[i]=9.0e9;
      if ( fits_write_img(ofptrs,TFLOAT,fp,imsize,rowdata1,&status) )
        printerror( status );            
      fp+=imsize;
    }
  printf("start closing images\n");
  if ( fits_close_file(ofptrd, &status) ) 
    printerror( status );
  if ( fits_close_file(ofptrs, &status) ) 
    printerror( status ); 

  printf("start removing images\n");
  for(k=1;k<=nf;k++)
    {
      strcpy(data,ffname[k]);
      sprintf(filename,"bss%s.fits",data1);
      filename[strlen(filename)]=(char)NULL;
      remove(filename);
      sprintf(filename,"bdf%s.fits",data1);
      filename[strlen(filename)]=(char)NULL;
      remove(filename);
    }
  for(i=0;i<(*xd);i++)
    {
      free(outd[i]);
      free(outs[i]);
    }
  /* imhead=fitsrhead(image,&length,&nb);
  impics=fitsrimage(image,nb,imhead);
  setburnedout(SATUR);
  setborder(border);
  setbmin(MSPEAK);
  setsecpix((double)kpsc);
  setmaxcat(nstar);
  settolerance(tol);
  if(!SetWCSFITS(image,imhead,impics,"UA2",1))
    {  
      printf("unable to obtain a wcs fit\n"); 
    }
  else
    {
      printf("fitswimage returns %d\n",fitswimage(image,imhead,impics));
      } */
}

long round(float xx)
{
  int i;
  float r;

  if(xx>=0.0)
    {
      i = (long) xx;
      r = xx - i;
      if ( r < 0.5 )
        return i;
      else
        return (i+1);
    }
  else
    {
      xx=0.0-xx;
      i = (long) xx;
      r = xx - i;
      if ( r < 0.5 )
        return (0-i);
      else
        return (0-(i+1));
    }
}

void crclip(float pp[],float ss[],int flag[], int *nd)
{
  float median, r[200], s[200], fact, tmp, sig, smed;
  int i, cc, j, ndat;
  long in,maxi;

  ndat=(*nd);
  for(i=1;i<=ndat;i++) 
    {
      if((ss[i]>0.0) && (ss[i]<9.0e9)) flag[i] = 1;
      else flag[i]=0;
    }
  cc = zcount(pp,ss,&ndat);
  if( (ndat-cc)<=1 )
    {
      for(i=1;i<=ndat;i++) 
        if((ss[i]==0.0)||(ss[i]>=9.0e9)) flag[i] = 0;
    }
  else
    {
      j=1;
      for(i=1;i<=ndat;i++)
        {
          if ((ss[i]!=0.0) && (ss[i]<9.0e9)) 
            {
              r[j]=pp[i];
              s[j]=ss[i];
              j++;
            }
        }
      in=(long)(j-1);
      median = med(r,&in);
      smed = med(s,&in); 
    
      do
	{ 
	  tmp=0; maxi=0;
	  for(i=1;i<=ndat;i++) 
	    {
	      if ((ss[i]!=0.0) && (flag[i]!=0) && (ss[i]<9.0e9)) 
		{
		  fact = fabs(pp[i]-median)/(smed);
		  if(fact>sclip) { tmp++; flag[i]=0;}
		  else { maxi++; r[maxi]=pp[i]; s[maxi]=ss[i]; }
		}
	    }
	  median = med(r,&maxi);
	  smed = med(s,&maxi); 
	} while(tmp!=0); 
    }
}
 
void printerror(int status)
{
    /*****************************************************/
    /* Print out cfitsio error messages and exit program */
    /*****************************************************/
 
    char status_str[FLEN_STATUS], errmsg[FLEN_ERRMSG];
  
    if (status)
      fprintf(stderr, "\n*** Error occurred during program execution ***\n");
 
    fits_get_errstatus(status, status_str);   /* get the error description */
    fprintf(stderr, "\nstatus = %d: %s\n", status, status_str);
 
    /* get first message; null if stack is empty */
    if ( fits_read_errmsg(errmsg) ) 
    {
         fprintf(stderr, "\nError message stack:\n");
         fprintf(stderr, " %s\n", errmsg);
 
         while ( fits_read_errmsg(errmsg) )  /* get remaining messages */
             fprintf(stderr, " %s\n", errmsg);
    }
 
    exit( status );       /* terminate the program, returning error status */
}

float med(float *p, long *dim)
{
  float tmp;
  long n,flag;
 
  n=(long)(*dim);
  if(n==0)
    return 0.0;
  else
    {
      sort(n,p);
      flag=round(0.5*(float)n);
      if((2*flag-n)!=0)
	return p[flag];
      else
	return 0.5*(p[flag]+p[flag+1]);
    }
}
 
void sort(unsigned long n, float *arr)
{
  unsigned long i,ir=n,j,k,l=1;
  int jstack=0,istack[51];
  float a,temp;
  
  for (;;) {
    if (ir-l < M) {
      for (j=l+1;j<=ir;j++) {
        a=arr[j];
        for (i=j-1;i>=1;i--) {
          if (arr[i] <= a) break;
          arr[i+1]=arr[i];
        }
        arr[i+1]=a;
      }
      if (jstack == 0) break;
      ir=istack[jstack--];
      l=istack[jstack--];
    } else {
      k=(l+ir) >> 1;
      SWAP(arr[k],arr[l+1])
        if (arr[l+1] > arr[ir]) {
          SWAP(arr[l+1],arr[ir])
            }
      if (arr[l] > arr[ir]) {
        SWAP(arr[l],arr[ir])
          }
      if (arr[l+1] > arr[l]) {
        SWAP(arr[l+1],arr[l])
          }
      i=l+1;
      j=ir;
      a=arr[l];
      for (;;) {
        do i++; while (arr[i] < a);
        do j--; while (arr[j] > a);
        if (j < i) break;
        SWAP(arr[i],arr[j]);
      }
      arr[l]=arr[j];
      arr[j]=a;
      jstack += 2;
      if (jstack > NSTACK) printf("NSTACK too small in sort.");
      if (ir-i+1 >= j-l) {
        istack[jstack]=ir;
        istack[jstack-1]=i;
        ir=j-1;
      } else {
        istack[jstack]=j-1;
        istack[jstack-1]=l;
        l=i;
      }
    }
  }
}

int zcount(float pp[], float ss[], int *imnum)
{
  int i, c;
 
  c=0;
  for(i=1;i<=(*imnum);i++)
    if((ss[i]==0)) c++;
  return c;
}
 
