procedure stk_fix ( stack )

string stack     
struct *list1

#  Interactive script to allow identification of the 
#  fiducial star chosen for all stacks to be stacked
#  by 'stk_stk'.                                                                    

begin
        string pre, onumber, isx_frame
        real x, y, xfid, yfid, xoff2, yoff2

#  This is taken from 'p_dither.cl'
 
        pclear ("init.dat") ; pclear ("slist")  
        display (stack, 1, erase-, bor+, fill+, zs-, zr-, z1=-200, z2=200 )

#  First show fiducial star XY computed from header

	  keypar(stack,"XFID",silent+)
	  xfid = real(keypar.value)
	  keypar(stack,"YFID",silent+)
	  yfid = real(keypar.value)
	  keypar(stack,"XOFF2",silent+)
	  xoff2 = real(keypar.value)
	  keypar(stack,"YOFF2",silent+)
	  yoff2 = real(keypar.value)

	x = xfid + xoff2 ; y = yfid + yoff2
				
	pclear ( "xy.dat")
	print ( x,"  ",y, > "xy.dat")

        display (stack, 1, fill+, zs-, zr-, z1=-200, z2=200 )
        tvmark (1, coords="xy.dat", mark="circle", radii="15",color=205)
                 
#  Use imexam to interactively get coords for fiducial star
                                                                                                                
        print ( "")
        print ( "  >>>>> Identify the true fiducial star  ( a  q )  " )
        print ( "")
                                                                                                                       
        imexamine ( stack,1,keeplog+,logfile='slist' )
        !egrep -v '#' slist | awk '{print $1, $2 }' > init.dat           
                                                                                                                                                        # Feed imexam coordinates to center task and 
# use center task to get refined coordinates of fiducial star.
                                                                                                                                                         
# Make sure to set centerpars and datapars used by center task 
# as follows:

  center.verify = no
  centerpars.calgori="centroid"
  centerpars.cbox=2.5
  centerpars.cthresh=0
  centerpars.minsnra=1
  centerpars.cmaxite=10
  centerpars.maxshif=1
  centerpars.clean=no
  centerpars.rclean=1
  centerpars.rclip=2
  centerpars.kclean=3
  centerpars.mkcente=no
  datapars.scale=0.125
  datapars.fwhmpsf=2.5
  datapars.emissio=yes
  datapars.sigma=INDEF
  datapars.datamin=INDEF
  datapars.datamax=INDEF
  datapars.noise="poisson"
  datapars.ccdread=""
  datapars.gain=""
  datapars.readnoi=0
  datapars.epadu=1
  datapars.exposur=""
  datapars.airmass=""
  datapars.filter=""
  datapars.obstime=""
  datapars.itime=1

	pclear ( "results.dat" ) ; pclear ( "xy.dat" )
                                                                                                   
    center (stack, coords="init.dat", output="results.dat", interactive=no, radplots=no, verify=no, update=no)
      
 !egrep -v '#' results.dat | egrep -v '_' | awk '{print $1, $2 }' > xy.dat

	list1 = "" ; list1 = "xy.dat"
	while ( fscan ( list1, x, y) != EOF )	{ }
	  
	  parkey(x,stack,"XSTAR",add+)
	  parkey(y,stack,"YSTAR",add+)

end
